(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('ol/Map.js'), require('olgm/layer/Google.js'), require('olgm/interaction.js'), require('olgm/OLGoogleMaps.js'), require('ol'), require('ol/Overlay'), require('ol/proj'), require('ol/layer/Tile'), require('ol/source/OSM'), require('ol/geom'), require('ol/style'), require('ol/source'), require('ol/layer'), require('ol/interaction'), require('ol/proj.js'), require('ol-ext/layer/AnimatedCluster'), require('ol-ext/interaction/selectCluster'), require('ol/geom/Polygon'), require('ol/extent'), require('ol/control'), require('sweetalert2'), require('ol/style/IconAnchorUnits'), require('rxjs'), require('rxjs/operators'), require('ol/style/Circle'), require('ol/geom/LinearRing'), require('jsts/dist/jsts'), require('ol/format/WKT'), require('ol/format/WFS'), require('ol/loadingstrategy'), require('ol/format/GML2'), require('@angular/forms'), require('ngx-spinner'), require('ngx-color-picker'), require('ngbi-filters'), require('@angular/core'), require('@angular/common/http'), require('@ng-bootstrap/ng-bootstrap'), require('@angular/platform-browser')) :
    typeof define === 'function' && define.amd ? define('ngbi-map', ['exports', 'ol/Map.js', 'olgm/layer/Google.js', 'olgm/interaction.js', 'olgm/OLGoogleMaps.js', 'ol', 'ol/Overlay', 'ol/proj', 'ol/layer/Tile', 'ol/source/OSM', 'ol/geom', 'ol/style', 'ol/source', 'ol/layer', 'ol/interaction', 'ol/proj.js', 'ol-ext/layer/AnimatedCluster', 'ol-ext/interaction/selectCluster', 'ol/geom/Polygon', 'ol/extent', 'ol/control', 'sweetalert2', 'ol/style/IconAnchorUnits', 'rxjs', 'rxjs/operators', 'ol/style/Circle', 'ol/geom/LinearRing', 'jsts/dist/jsts', 'ol/format/WKT', 'ol/format/WFS', 'ol/loadingstrategy', 'ol/format/GML2', '@angular/forms', 'ngx-spinner', 'ngx-color-picker', 'ngbi-filters', '@angular/core', '@angular/common/http', '@ng-bootstrap/ng-bootstrap', '@angular/platform-browser'], factory) :
    (factory((global['ngbi-map'] = {}),global.Map,global.GoogleLayer,global.interaction_js,global.OLGoogleMaps,global.ol,global.Overlay,global.proj,global.TileLayer,global.OSM,global.geom,global.style,global.source,global.layer,global.interaction,global.proj_js,global.AnimatedCluster,global.SelectCluster,global.Polygon,global.extent,global.control,global.swal,global.IconAnchorUnits,global.rxjs,global.rxjs.operators,global.CircleStyle,global.LinearRing,global.jsts,global.WKT,global.WFS,global.loadingstrategy,global.GML2,global.ng.forms,global.ngxSpinner,global.ngxColorPicker,global.ngbiFilters,global.ng.core,global.ng.common.http,global.ngBootstrap,global.ng.platformBrowser));
}(this, (function (exports,Map,GoogleLayer,interaction_js,OLGoogleMaps,ol,Overlay,proj,TileLayer,OSM,geom,style,source,layer,interaction,proj_js,AnimatedCluster,SelectCluster,Polygon,extent,control,swal,IconAnchorUnits,rxjs,operators,CircleStyle,LinearRing,jsts,WKT,WFS,loadingstrategy,GML2,forms,ngxSpinner,ngxColorPicker,ngbiFilters,i0,http,ngBootstrap,platformBrowser) { 'use strict';

    Map = Map && Map.hasOwnProperty('default') ? Map['default'] : Map;
    GoogleLayer = GoogleLayer && GoogleLayer.hasOwnProperty('default') ? GoogleLayer['default'] : GoogleLayer;
    OLGoogleMaps = OLGoogleMaps && OLGoogleMaps.hasOwnProperty('default') ? OLGoogleMaps['default'] : OLGoogleMaps;
    Overlay = Overlay && Overlay.hasOwnProperty('default') ? Overlay['default'] : Overlay;
    TileLayer = TileLayer && TileLayer.hasOwnProperty('default') ? TileLayer['default'] : TileLayer;
    OSM = OSM && OSM.hasOwnProperty('default') ? OSM['default'] : OSM;
    AnimatedCluster = AnimatedCluster && AnimatedCluster.hasOwnProperty('default') ? AnimatedCluster['default'] : AnimatedCluster;
    SelectCluster = SelectCluster && SelectCluster.hasOwnProperty('default') ? SelectCluster['default'] : SelectCluster;
    var Polygon__default = 'default' in Polygon ? Polygon['default'] : Polygon;
    swal = swal && swal.hasOwnProperty('default') ? swal['default'] : swal;
    IconAnchorUnits = IconAnchorUnits && IconAnchorUnits.hasOwnProperty('default') ? IconAnchorUnits['default'] : IconAnchorUnits;
    CircleStyle = CircleStyle && CircleStyle.hasOwnProperty('default') ? CircleStyle['default'] : CircleStyle;
    LinearRing = LinearRing && LinearRing.hasOwnProperty('default') ? LinearRing['default'] : LinearRing;
    WKT = WKT && WKT.hasOwnProperty('default') ? WKT['default'] : WKT;
    WFS = WFS && WFS.hasOwnProperty('default') ? WFS['default'] : WFS;
    GML2 = GML2 && GML2.hasOwnProperty('default') ? GML2['default'] : GML2;

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngbi-map.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgbiMapService = /** @class */ (function () {
        function NgbiMapService() {
        }
        NgbiMapService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgbiMapService.ctorParameters = function () { return []; };
        /** @nocollapse */ NgbiMapService.ngInjectableDef = i0.defineInjectable({ factory: function NgbiMapService_Factory() { return new NgbiMapService(); }, token: NgbiMapService, providedIn: "root" });
        return NgbiMapService;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngbi-map.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgbiMapComponent = /** @class */ (function () {
        function NgbiMapComponent() {
        }
        /**
         * @return {?}
         */
        NgbiMapComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        NgbiMapComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ngbi-ngbi-map',
                        template: "\n    <p>\n      ngbi-map works!\n    </p>\n  "
                    }] }
        ];
        /** @nocollapse */
        NgbiMapComponent.ctorParameters = function () { return []; };
        return NgbiMapComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/mapa/mapa.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MapaComponent = /** @class */ (function () {
        function MapaComponent(modalService, http$$1, spinner, calendar, config, element, renderer, _parserFormatter) {
            this.modalService = modalService;
            this.http = http$$1;
            this.spinner = spinner;
            this.calendar = calendar;
            this.renderer = renderer;
            this._parserFormatter = _parserFormatter;
            this.clicExterno = new i0.EventEmitter();
            this.utilizandoPopUp = false;
            // PARAMETROS DE BUSQUEDA
            this.texto = "";
            this.coordenadasActual = [];
            this.totalEncontrados = 0;
            // OTROS
            this.tipoSeleccionado = 'Polygon';
            this.Intersecciones = [];
            this.modoInterseccion = false;
            this.modoDiferencia = false;
            this.modoInterseccionAutomatica = false;
            this.tipoCirculo = 0;
            this.habilitarDireccion = true;
            this.hole = {};
            this.center = [];
            this.color = 'rgba(0,0,255,1)';
            this.zoom = 2;
            this.mapaPredeterminado = '';
            this.capasActuales = [];
            this.procesandoFeature = false;
            this.filtrosGlobales = [];
            this.showOption = false;
            this.busquedasTexto = [];
            this.teclaPresionada = "";
            this.featuresSeleccionados = [];
            this.inputPlaceholder = "Direcciones";
            this.viewChanged = new rxjs.Subject();
            this.isCollapsed = true;
            this.isCollapsedR = true;
            this.figurasActivas = [];
            this.tiposOrigenes = []; //String concatenado.
            //String concatenado.
            this.busquedasActuales2 = [];
            this.busquedaTextuales = [];
            this.paginacionGeo = {
                pagActual: 1,
                RPP: 10,
                geometrysWKT: null,
                tipoOrigen: null,
                UUID: null
            };
            //La informacion que se mostraria en el detalle
            this.infoDetalle = [];
            this.infoVista = [];
            //Las keys array de array
            this.infoDetTitulo = [];
            //Los valores array de array
            this.infoDetValues = [];
            this.busquedaAnterior = [];
            this.chkActualizarResult = false;
            this.infoTitulos = [];
            this.infoDetBotones = [];
        }
        /**
         * @param {?} event
         * @return {?}
         */
        MapaComponent.prototype.handleKeyboardDownEvent = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                this.teclaPresionada = event.key;
            };
        /**
         * @param {?} event
         * @return {?}
         */
        MapaComponent.prototype.handleKeyboardUpEvent = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (this.teclaPresionada == event.key && event.key == "Control") {
                    this.teclaPresionada = null;
                    this.featuresSeleccionados = [];
                }
                // console.log(event.key);
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.obtenerConfiguracion().subscribe(( /**
                 * @param {?} response
                 * @return {?}
                 */function (response) {
                    console.log("Configuraciones Api>>>>", response);
                    try {
                        _this.confBusquedaGeo = response.modBusqueda;
                    }
                    catch (_a) {
                        console.log("Error", "No se encontro configuracion Busqueda Geo!!!");
                    }
                    try {
                        _this.confBusquedaText = response.modBusquedaTextuales;
                    }
                    catch (_b) {
                        console.log("Error", "No se encontro configuracion busqueda textual!!!");
                    }
                    try {
                        _this.confInicializacion = response.inicializacion;
                    }
                    catch (_c) {
                        console.log("Error", "No se encontro configuracion de Inicializacion!!!");
                    }
                    try {
                        _this.confCapas = response.capas.Property1;
                    }
                    catch (_d) {
                        console.log("Error", "No se encontro configuracion de capas!!!");
                    }
                    _this.confResultadosVista = response.modResultadosVista;
                    // {
                    //   "Chat":{Vista:["NombreAlerta", "FechaCreacion", "Tipo", "Mensaje"],CampoEspeciales:{JSON:['Modelo'],fecha:["FechaCreacion"]},botones:[{class:"btn btn-primary",contenido:"prueba",accion:"accion_de_prueba"}]},
                    //   "Bts":{Vista:["radio","mcc","net","area","cell","unit","range","samples","changeable","created","updated"]},
                    //   "Nacional":{Vista:["N_Completo","NOM_EDO","CALLE","COLONIA","CP","OCUPACION"]}
                    // }
                    _this.confBusquedaGeo.busquedas.forEach(( /**
                     * @param {?} busqueda
                     * @return {?}
                     */function (busqueda) {
                        _this.busquedasActuales2.push(busqueda);
                        if (busqueda.visible == true) {
                            //reajuste
                            busqueda.visible = false;
                            _this.cambiarStatusBusqueda(busqueda.titulo);
                            // this.tiposOrigenes.push(busqueda.nombre);
                        }
                    }));
                    // {nombre:config.titulo,URL:config.busquedaTexto.URL
                    // ,icon:config.busquedaTexto.icon,type:config.busquedaTexto.type,
                    //   typeRequest:config.busquedaTexto.typeRequest,typeResponse:config.busquedaTexto.typeResponse,placeholder:config.busquedaTexto.placeholder};
                    _this.busquedasTexto.push({
                        titulo: "Google", nombre: "Google maps",
                        icon: "https://www.google.com/maps/about/images/home/home-maps-icon.svg?mmfb=de7ec406c933d20ac2caf9114c2434a9",
                        placeholder: "direcciones"
                    });
                    _this.confBusquedaText.busquedaTextuales.forEach(( /**
                     * @param {?} busqueda
                     * @return {?}
                     */function (busqueda) {
                        _this.busquedasTexto.push(busqueda);
                    }));
                    _this.inicializarVariables();
                    _this.inicializarMapa();
                    _this.inicializarEventos();
                    _this.crearLayersBusqueda();
                    if (_this.filtroInicial) {
                        _this.busquedaInicial();
                    }
                    _this.viewSubcription = _this.viewChanged.pipe(operators.distinctUntilChanged(), operators.debounceTime(300)).subscribe(( /**
                     * @return {?}
                     */function () {
                        console.log(_this.chkActualizarResult);
                        if (_this.buscando) {
                            if (_this.chkActualizarResult) {
                                _this.buscarArea.nativeElement.style.display = "none";
                                if (_this.source.getFeatures().length == 0) {
                                    _this.figurasActivas = [];
                                    _this.generarFiguraVentana();
                                }
                                else {
                                    /** @type {?} */
                                    var contieneFeature_1 = false;
                                    _this.source.getFeatures().forEach(( /**
                                     * @param {?} feature
                                     * @return {?}
                                     */function (feature) {
                                        /** @type {?} */
                                        var ext1 = _this.map.getView().calculateExtent(_this.map.getSize());
                                        /** @type {?} */
                                        var ext2 = feature.getGeometry().getExtent();
                                        if (extent.containsExtent(ext1, ext2))
                                            contieneFeature_1 = true;
                                    }));
                                    //Si no contiene el feature en la vista
                                    if (contieneFeature_1 == false) {
                                        _this.figurasActivas = [];
                                        _this.generarFiguraVentana();
                                    }
                                }
                                //if() layer de dibujos tiene dijos?
                                _this.consultarV2();
                            }
                            else {
                                _this.buscarArea.nativeElement.style.display = "block";
                                _this.labelActualizar.nativeElement.style.display = "block";
                                //activar boton
                            }
                        }
                    }));
                }));
                //this.habilitarDireccion=false;
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.generarFiguraVentana = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var extent$$1 = this.map.getView().calculateExtent(this.map.getSize());
                /** @type {?} */
                var extGeometry = Polygon.fromExtent(extent$$1);
                /** @type {?} */
                var coords = extGeometry.getCoordinates();
                coords = coords[0];
                /** @type {?} */
                var coordsLatLon = [];
                coordsLatLon.push(proj.toLonLat([coords[0][0], coords[0][1]])[0]);
                coordsLatLon.push(proj.toLonLat([coords[0][0], coords[0][1]])[1]);
                coordsLatLon.push(proj.toLonLat([coords[1][0], coords[1][1]])[0]);
                coordsLatLon.push(proj.toLonLat([coords[1][0], coords[1][1]])[1]);
                coordsLatLon.push(proj.toLonLat([coords[2][0], coords[2][1]])[0]);
                coordsLatLon.push(proj.toLonLat([coords[2][0], coords[2][1]])[1]);
                coordsLatLon.push(proj.toLonLat([coords[3][0], coords[3][1]])[0]);
                coordsLatLon.push(proj.toLonLat([coords[3][0], coords[3][1]])[1]);
                coordsLatLon.push(proj.toLonLat([coords[0][0], coords[0][1]])[0]);
                coordsLatLon.push(proj.toLonLat([coords[0][0], coords[0][1]])[1]);
                console.log(coordsLatLon);
                this.busquedaGeo(coordsLatLon, 'Polygon', 5, extent$$1);
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.inicializarVariables = /**
         * @return {?}
         */
            function () {
                this.infoBusquedas = [];
                this.busquedasActuales = [];
                this.content = document.getElementById('popup-content');
                this.container = document.getElementById('popup');
                this.closer = document.getElementById('popup-closer');
                console.log("CONFIGURACION INICIAL >>>", this.confInicializacion);
                if (this.confInicializacion) {
                    this.center = proj.fromLonLat(this.confInicializacion.center);
                    this.color = this.confInicializacion.drawColor;
                    this.zoom = this.confInicializacion.zoom;
                    this.mapaPredeterminado = this.confInicializacion.mapaPredeterminado;
                }
                // this.confBusquedaGeo.busquedas.forEach(busqueda => {
                //   this.busquedasActuales2.push(busqueda);
                // });
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.inicializarMapa = /**
         * @return {?}
         */
            function () {
                var _this = this;
                proj_js.addCommon();
                this.overlay = new Overlay({
                    element: this.container,
                    autoPan: true,
                    autoPanAnimation: {
                        duration: 250
                    }
                });
                /** @type {?} */
                var center = this.center;
                // this.googleLayer.setVisible(true);
                this.OSMLayer = new TileLayer({
                    source: new OSM,
                    zIndex: 0
                });
                this.source = new source.Vector();
                /** @type {?} */
                var vector = new layer.Vector({
                    source: this.source,
                    opacity: 0.5,
                    zIndex: 0,
                });
                try {
                    this.googleLayer = new GoogleLayer();
                    /** @type {?} */
                    var strokeProp_1 = new style.Stroke({ color: 'black', width: 2 });
                    /** @type {?} */
                    var goldFill_1 = new style.Fill({ color: 'blue' });
                    /** @type {?} */
                    var styleCache_1 = {};
                    /** @type {?} */
                    var selectStyle_1 = {};
                    this.googleLayer.style = ( /**
                     * @param {?} feature
                     * @return {?}
                     */function (feature) {
                        if (feature.get('features').length > 1) {
                            /** @type {?} */
                            var size = void 0;
                            if (!feature || feature.get('features') === undefined) {
                                size = 0;
                            }
                            else {
                                size = feature.get('features').length;
                            }
                            /** @type {?} */
                            var style$$1 = styleCache_1[size];
                            if (!style$$1) {
                                style$$1 = new style.Style({
                                    image: new style.RegularShape({
                                        fill: goldFill_1,
                                        stroke: strokeProp_1,
                                        points: 4,
                                        radius: 10,
                                        angle: Math.PI / 4
                                    }),
                                    text: new style.Text({
                                        text: size.toString(),
                                        fill: new style.Fill({
                                            color: '#fff'
                                        })
                                    })
                                });
                                styleCache_1[size] = style$$1;
                            }
                            return style$$1;
                        }
                        else {
                            /** @type {?} */
                            var feat = feature.get('features');
                            /** @type {?} */
                            var src = feat[0].getStyle().getImage().getSrc();
                            /** @type {?} */
                            var style$$1 = feat[0].getStyle();
                            if (!selectStyle_1[src]) {
                                selectStyle_1[src] = style$$1;
                            }
                            return selectStyle_1[src];
                        }
                    });
                }
                catch (_a) {
                    console.log("Error googleLayer", "Hubo problemas con la capa de google maps y no se cargará...");
                }
                this.view = new ol.View({
                    center: center,
                    zoom: this.zoom,
                    maxZoom: 20,
                    minZoom: 4
                });
                this.map = new Map({
                    controls: control.defaults().extend([
                        new control.FullScreen()
                    ]),
                    interactions: interaction_js.defaults(),
                    layers: [
                        this.OSMLayer, this.googleLayer, vector
                    ],
                    overlays: [this.overlay],
                    target: 'map',
                    view: this.view,
                });
                // sync(this.map);
                this.olGM = new OLGoogleMaps({ map: this.map, watch: {
                        'vector': false
                    } });
                this.olGM.activate();
                if (this.mapaPredeterminado == "OSM") {
                    this.googleLayer.setVisible(false);
                    this.OSMLayer.setVisible(true);
                }
                else if (this.mapaPredeterminado == "GoogleMaps") {
                    this.googleLayer.setVisible(true);
                    this.OSMLayer.setVisible(false);
                }
                if (this.confCapas) {
                    this.confCapas.forEach(( /**
                     * @param {?} configCapa
                     * @return {?}
                     */function (configCapa) {
                        /*
                                "nombre":"CDMA",
                                "URL":"http://127.0.0.1/cgi-bin/mapserv.exe?MAP=/ms4w/apps/bts/btsMap.map&service=WFS&version=1.0.0&request=GetFeature&typename=btsCDMA&outputFormat=gml3&maxFeatures=5000&bbox=",
                                "tipoEntrada":"WKT",
                                "tipoSalida":"ClusterAnimated",
                                "bbox":true,
                                "minZoom":15,
                                "stylePrefab":1,
                                "visible":false
                                */
                        /** @type {?} */
                        var newLayer = _this.generarLayer(configCapa, _this.generarSource(configCapa));
                        console.log("LayerCreadoCapa", newLayer);
                        _this.map.addLayer(newLayer);
                        _this.capasActuales.push({ "nombre": configCapa.nombre, "layer": newLayer, config: rxjs.config });
                        if (configCapa.busquedaTexto) {
                            _this.busquedasTexto.push({ nombre: configCapa.nombre, URL: configCapa.busquedaTexto.URL, icon: configCapa.busquedaTexto.icon, type: configCapa.busquedaTexto.type,
                                typeRequest: configCapa.busquedaTexto.typeRequest, typeResponse: configCapa.busquedaTexto.typeResponse, placeholder: configCapa.busquedaTexto.placeholder });
                        }
                        // this.generarLayerCluster(this.generarSourceCluster(configCapa.url));
                    }));
                }
                /** @type {?} */
                var radiusDinamyc = 60 - (this.view.getZoom() * 2.8);
                this.mapaCalor = new layer.Heatmap({
                    source: new source.Vector(),
                    weight: ( /**
                     * @param {?} feature
                     * @return {?}
                     */function (feature) {
                        /** @type {?} */
                        var total = parseInt(feature.get('total'));
                        /** @type {?} */
                        var weight = total > 25 ? 1 : total > 8 ? 0.7 : 0.4;
                        return weight;
                    }),
                    // gradient: [
                    //        'hsl(240, 100%, 50%)',
                    //        'hsl(180, 100%, 50%)',
                    //        'hsl(120, 100%, 50%)',
                    //        'hsl(60, 100%, 50%)'
                    // ],
                    radius: radiusDinamyc,
                    blur: 22,
                    opacity: 0.80
                });
                this.mapaCalor.setZIndex(5000);
                this.map.addLayer(this.mapaCalor);
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.inicializarEventos = /**
         * @return {?}
         */
            function () {
                this.cerrarPopup(this.closer, this.selectedFeatures, this.overlay, this);
                // let dragBox = new DragBox({
                //   condition: platformModifierKeyOnly,
                //   onBoxEnd: ()=>{
                //     let coords = dragBox.getGeometry().getFlatCoordinates();
                //     this.busquedaGeo(coords,'Rectangle',5,dragBox.getGeometry().getExtent());
                //   }
                // });
                // let select = new Select({
                // style: this.arregloCapas[0].cluster.getStyle()
                // });
                // this.selectedFeatures = select.getFeatures(); 
                // console.log(select);
                // this.map.addInteraction(select);
                // this.desactivarZoomDobleClick(this.map);
                // this.eventDoubleClick(this.map,this.selectedFeatures);  
                this.selectCluster = new SelectCluster({
                // style: (features)=>{
                //   if(features.get('feature').length===1){
                //     let feature = features.get('feature')[0];
                //     return feature.getStyle();
                //   } 
                // }
                });
                this.selectedFeatures = this.selectCluster.getFeatures();
                this.selectedOn(this.selectedFeatures, this);
                this.map.addInteraction(this.selectCluster);
                // this.map.addInteraction(dragBox);
                // this.cambiarMapaCalor(false); ACTIVAR
                // this.ModificacionTamañoFeature(modifyS,this)
                // let modifyS = new Modify({source: this.source});
                // this.map.addInteraction(modifyS);
                this.eventoClick(this.map, this, this.content, this.overlay);
                this.InitBusquedaGM(true, this.direccionesElement.nativeElement, this.map);
                // this.filtrosGlobales = [];
                // this.confBusquedaGeo.filtros.forEach(filtro => {
                //   busqueda.filtros.forEach(filtro => {
                //     let obj:Filter = new Filter();
                //     obj.name=filtro.nombre;
                //     obj.title=filtro.titulo;
                //     obj.type=filtro.tipo;//date, text, select
                //     obj.valueFormat=filtro.valordefault;//date, text, select
                //     this.filtrosGlobales.push(obj);
                //   });
                // }
                // });
                this.clickDerechoMenu();
                this.InicializarEventoViewChange(this);
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.crearLayersBusqueda = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var strokeProp = new style.Stroke({ color: 'black', width: 2 });
                /** @type {?} */
                var goldFill = new style.Fill({ color: 'blue' });
                // let clusterSource = new Cluster({
                //   distance: parseInt('50', 10),
                //   source: new Vector()
                // });
                /** @type {?} */
                var styleCache = {};
                /** @type {?} */
                var style$$1 = ( /**
                 * @param {?} feature
                 * @param {?} resolution
                 * @return {?}
                 */function (feature, resolution) {
                    /** @type {?} */
                    var size = feature.get('features').length;
                    // console.log('Feature style',feature);
                    /** @type {?} */
                    var style$$1;
                    /** @type {?} */
                    var total = 0;
                    feature.get('features').forEach(( /**
                     * @param {?} element
                     * @return {?}
                     */function (element) {
                        total += parseInt(element.values_.total);
                    }));
                    if (size == 1) {
                        console.log("total", feature.get('features')[0].values_.total);
                        total = feature.get('features')[0].values_.total;
                    }
                    console.log(total);
                    if (total > 1) {
                        console.log("feature Style", feature);
                        /** @type {?} */
                        var color = total > 25 ? "192,0,0" : total > 8 ? "255,128,0" : "0,128,0";
                        /** @type {?} */
                        var radius = Math.max(8, Math.min(total * 0.75, 20));
                        /** @type {?} */
                        var dash1 = 2 * Math.PI * radius / 6;
                        /** @type {?} */
                        var dash2 = [0, dash1, dash1, dash1, dash1, dash1, dash1];
                        style$$1 = styleCache[total] = new style.Style({
                            image: new CircleStyle({
                                radius: radius,
                                stroke: new style.Stroke({
                                    color: "rgba(" + color + ",0.5)",
                                    width: 15,
                                    lineDash: dash2,
                                    lineCap: "butt"
                                }),
                                fill: new style.Fill({
                                    color: "rgba(" + color + ",1)"
                                })
                            }),
                            text: new style.Text({
                                text: total.toString(),
                                fill: new style.Fill({
                                    color: '#fff'
                                })
                            })
                        });
                        return [style$$1];
                    }
                    else {
                        try {
                            /** @type {?} */
                            var feat = feature.get('features');
                            /** @type {?} */
                            var src = feat[0].getStyle().getImage().getSrc();
                            /** @type {?} */
                            var style_1 = feat[0].getStyle();
                            if (!styleCache[src]) {
                                styleCache[src] = style_1;
                            }
                            return styleCache[src];
                        }
                        catch (_a) {
                            /** @type {?} */
                            var style_2 = new style.Style({
                                image: new style.RegularShape({
                                    fill: goldFill,
                                    stroke: strokeProp,
                                    points: 4,
                                    radius: 10,
                                    angle: Math.PI / 4
                                }),
                                text: new style.Text({
                                    text: feature.get('features')[0].values_.total,
                                    fill: new style.Fill({
                                        color: '#fff'
                                    })
                                })
                            });
                            return style_2;
                        }
                    }
                });
                /** @type {?} */
                var styleTexto = ( /**
                 * @param {?} feature
                 * @param {?} resolution
                 * @return {?}
                 */function (feature, resolution) {
                    /** @type {?} */
                    var size = feature.get('features') != undefined ? feature.get('features').length : 1;
                    console.log('Feature style', feature);
                    /** @type {?} */
                    var style$$1;
                    if (size > 1) {
                        /** @type {?} */
                        var color = size > 25 ? "192,0,0" : size > 8 ? "255,128,0" : "0,128,0";
                        /** @type {?} */
                        var radius = Math.max(8, Math.min(size * 0.75, 20));
                        /** @type {?} */
                        var dash1 = 2 * Math.PI * radius / 6;
                        /** @type {?} */
                        var dash2 = [0, dash1, dash1, dash1, dash1, dash1, dash1];
                        style$$1 = styleCache[size] = new style.Style({
                            image: new CircleStyle({
                                radius: radius,
                                stroke: new style.Stroke({
                                    color: "rgba(" + color + ",0.5)",
                                    width: 15,
                                    lineDash: dash2,
                                    lineCap: "butt"
                                }),
                                fill: new style.Fill({
                                    color: "rgba(" + color + ",1)"
                                })
                            }),
                            text: new style.Text({
                                text: size.toString(),
                                fill: new style.Fill({
                                    color: '#fff'
                                })
                            })
                        });
                        return [style$$1];
                    }
                    else {
                        try {
                            /** @type {?} */
                            var feat = feature.get('features');
                            /** @type {?} */
                            var src = feat[0].getStyle().getImage().getSrc();
                            /** @type {?} */
                            var style_3 = feat[0].getStyle();
                            if (!styleCache[src]) {
                                styleCache[src] = style_3;
                            }
                            return styleCache[src];
                        }
                        catch (_a) {
                            /** @type {?} */
                            var style_4 = new style.Style({
                                image: new style.RegularShape({
                                    fill: goldFill,
                                    stroke: strokeProp,
                                    points: 4,
                                    radius: 10,
                                    angle: Math.PI / 4
                                }),
                                text: new style.Text({
                                    text: "1",
                                    fill: new style.Fill({
                                        color: '#fff'
                                    })
                                })
                            });
                            return style_4;
                        }
                    }
                });
                // let clusterAnimado = new VectorLayer({
                //   source:clusterSource,
                //   // animationDuration: 700,
                //   style:style
                // })
                /** @type {?} */
                var styleVector = ( /**
                 * @param {?} feature
                 * @param {?} resolution
                 * @return {?}
                 */function (feature, resolution) {
                    /** @type {?} */
                    var size = feature.get('total') || 1;
                    // console.log('Size',size);
                    /** @type {?} */
                    var style$$1;
                    if (size > 1) {
                        /** @type {?} */
                        var color = size > 25 ? "192,0,0" : size > 8 ? "255,128,0" : "0,128,0";
                        /** @type {?} */
                        var radius = Math.max(8, Math.min(size * 0.75, 20));
                        /** @type {?} */
                        var dash1 = 2 * Math.PI * radius / 6;
                        /** @type {?} */
                        var dash2 = [0, dash1, dash1, dash1, dash1, dash1, dash1];
                        style$$1 = styleCache[size] = new style.Style({
                            image: new CircleStyle({
                                radius: radius,
                                stroke: new style.Stroke({
                                    color: "rgba(" + color + ",0.5)",
                                    width: 15,
                                    lineDash: dash2,
                                    lineCap: "butt"
                                }),
                                fill: new style.Fill({
                                    color: "rgba(" + color + ",1)"
                                })
                            }),
                            text: new style.Text({
                                text: size.toString(),
                                fill: new style.Fill({
                                    color: '#fff'
                                })
                            })
                        });
                        return [style$$1];
                    }
                    else {
                        try {
                            /** @type {?} */
                            var feat = feature.get('features');
                            /** @type {?} */
                            var src = feat[0].getStyle().getImage().getSrc();
                            /** @type {?} */
                            var style_5 = feat[0].getStyle();
                            if (!styleCache[src]) {
                                styleCache[src] = style_5;
                            }
                            return styleCache[src];
                        }
                        catch (_a) {
                            /** @type {?} */
                            var style_6 = new style.Style({
                                image: new style.RegularShape({
                                    fill: goldFill,
                                    stroke: strokeProp,
                                    points: 4,
                                    radius: 10,
                                    angle: Math.PI / 4
                                }),
                                text: new style.Text({
                                    text: "1",
                                    fill: new style.Fill({
                                        color: '#fff'
                                    })
                                })
                            });
                            return style_6;
                        }
                    }
                });
                this.busquedaFacetLayer = new layer.Vector({
                    style: styleVector,
                    source: new source.Vector()
                });
                this.busquedaTextoLayer = new layer.Vector({
                    style: styleTexto,
                    source: new source.Cluster({
                        distance: parseInt('50', 10),
                        source: new source.Vector()
                    })
                });
                this.busquedaClusterLayer = new layer.Vector({
                    style: style$$1,
                    source: new source.Cluster({
                        distance: parseInt('50', 10),
                        source: new source.Vector()
                    })
                });
                this.map.addLayer(this.busquedaFacetLayer);
                this.map.addLayer(this.busquedaClusterLayer);
                this.map.addLayer(this.busquedaTextoLayer);
                console.log("Se agrego los layer Facet,Cluster!!", this.map.getLayers());
            };
        /**
         * @param {?} index
         * @param {?} iconos
         * @return {?}
         */
        MapaComponent.prototype.crearEstilo = /**
         * @param {?} index
         * @param {?} iconos
         * @return {?}
         */
            function (index, iconos) {
                /** @type {?} */
                var StylePrefab1 = (( /**
                 * @param {?} feature
                 * @return {?}
                 */function (feature) {
                    /** @type {?} */
                    var styleCache = {};
                    if (feature) {
                        /** @type {?} */
                        var size = feature.get('features').length || 0;
                        if (size > 1) {
                            /** @type {?} */
                            var color = size > 25 ? "192,0,0" : size > 8 ? "255,128,0" : "0,128,0";
                            /** @type {?} */
                            var radius = Math.max(8, Math.min(size * 0.75, 20));
                            styleCache[size] = new style.Style({
                                image: new CircleStyle({
                                    radius: radius,
                                    stroke: new style.Stroke({
                                        color: "rgba(" + color + ",0.3)",
                                        width: 15,
                                        // lineDash: dash2,
                                        lineCap: "butt"
                                    }),
                                    fill: new style.Fill({
                                        color: "rgba(" + color + ",0.8)"
                                    })
                                }),
                                text: new style.Text({
                                    text: size.toString(),
                                    fill: new style.Fill({
                                        color: '#fff'
                                    })
                                })
                            });
                            return styleCache[size];
                        }
                        else if (size == 1) {
                            // console.log("Object feature=>>>",feature['values_']['features'][0]);
                            try {
                                /** @type {?} */
                                var ftre_1 = feature['values_']['features'][0];
                                /** @type {?} */
                                var stilo_1;
                                iconos.valores.forEach(( /**
                                 * @param {?} valor
                                 * @return {?}
                                 */function (valor) {
                                    // if(ftre["values_"]["content"][iconos.campo]==){
                                    if (ftre_1["values_"][iconos.campo] == valor.valor) {
                                        stilo_1 = new style.Style({
                                            image: new style.Icon({
                                                anchor: [0.5, 20],
                                                anchorXUnits: IconAnchorUnits.FRACTION,
                                                anchorYUnits: IconAnchorUnits.PIXELS,
                                                crossOrigin: 'anonymous',
                                                src: valor.path,
                                                scale: valor.escala
                                            })
                                        });
                                        return;
                                    }
                                }));
                                return stilo_1;
                            }
                            catch (_a) {
                                /** @type {?} */
                                var color = "0,128,0";
                                /** @type {?} */
                                var radius = Math.max(8, Math.min(0.75, 20));
                                styleCache[size] = new style.Style({
                                    image: new CircleStyle({
                                        radius: radius,
                                        stroke: new style.Stroke({
                                            color: "rgba(" + color + ",0.3)",
                                            width: 15,
                                            lineCap: "butt"
                                        }),
                                        fill: new style.Fill({
                                            color: "rgba(" + color + ",0.8)"
                                        })
                                    }),
                                    text: new style.Text({
                                        text: "1",
                                        fill: new style.Fill({
                                            color: '#fff'
                                        })
                                    })
                                });
                            }
                            return styleCache[size];
                        }
                        else {
                            /** @type {?} */
                            var color = "0,128,0";
                            /** @type {?} */
                            var radius = Math.max(8, Math.min(0.75, 20));
                            styleCache[size] = new style.Style({
                                image: new CircleStyle({
                                    radius: radius,
                                    stroke: new style.Stroke({
                                        color: "rgba(" + color + ",0.3)",
                                        width: 15,
                                        lineCap: "butt"
                                    }),
                                    fill: new style.Fill({
                                        color: "rgba(" + color + ",0.8)"
                                    })
                                }),
                                text: new style.Text({
                                    text: "1",
                                    fill: new style.Fill({
                                        color: '#fff'
                                    })
                                })
                            });
                        }
                    }
                }));
                if (index == 0) {
                    return StylePrefab1;
                }
                else {
                    return StylePrefab1;
                }
                // this.stylePrefab[0]=StylePrefab1;
                // this.stylePrefab[0]=StylePrefab1;
                // this.stylePrefab[0]=StylePrefab1;
                /*
                CREAR Y AGREGAR OTRO ESTILOS POSIBLES DEL FEATURE
                
                
                
                */
            };
        /**
         * @param {?} configSource
         * @return {?}
         */
        MapaComponent.prototype.generarSource = /**
         * @param {?} configSource
         * @return {?}
         */
            function (configSource) {
                var _this = this;
                /** @type {?} */
                var extentString;
                switch (configSource.tipoEntrada) {
                    case "WFS":
                        return new source.Cluster({
                            distance: parseInt('50', 10),
                            source: new source.Vector({
                                format: new WFS(),
                                url: ( /**
                                 * @param {?} extent
                                 * @return {?}
                                 */function (extent$$1) {
                                    if (extent$$1[0] == Infinity)
                                        return "";
                                    extentString = extent$$1.join(',');
                                    // console.log("Extent=>>>>>>>>>>",extentString);
                                    return configSource.URL + "&bbox=" + extentString + "," + configSource.projection;
                                }),
                                strategy: ( /**
                                 * @return {?}
                                 */function () {
                                    // console.log(this.map.getView().getZoom());
                                    if (_this.map.getView().getZoom() <= configSource.minZoom) {
                                        // console.log("Min Zoom",this.map)
                                        return loadingstrategy.bbox(extent.createEmpty(), 0);
                                    }
                                    else
                                        return loadingstrategy.bbox(_this.map.getView().calculateExtent(_this.map.getSize()), _this.map.getView().getResolutionForExtent(_this.map.getView().calculateExtent(_this.map.getSize())));
                                })
                            })
                        });
                        break;
                    case "WMS":
                        console.log("WMS", configSource.URL);
                        return new source.TileWMS({
                            url: configSource.URL,
                            params: { 'LAYERS': configSource.Params['layers'], 'TILED': configSource.Params['tiled'] },
                            projection: configSource.projection,
                            serverType: configSource.serverType
                        });
                        break;
                    case "GML2":
                        return new source.Cluster({
                            distance: parseInt('50', 10),
                            source: new source.Vector({
                                format: new GML2(),
                                url: ( /**
                                 * @param {?} extent
                                 * @return {?}
                                 */function (extent$$1) {
                                    if (extent$$1[0] == Infinity)
                                        return "";
                                    extentString = extent$$1.join(',');
                                    // console.log("Extent=>>>>>>>>>>",extentString);
                                    return configSource.URL + "&bbox=" + extentString + "," + configSource.projection;
                                }),
                                strategy: ( /**
                                 * @return {?}
                                 */function () {
                                    // console.log(this.map.getView().getZoom());
                                    if (_this.map.getView().getZoom() <= configSource.minZoom) {
                                        // console.log("Min Zoom",this.map)
                                        return loadingstrategy.bbox(extent.createEmpty(), 0);
                                    }
                                    else
                                        return loadingstrategy.bbox(_this.map.getView().calculateExtent(_this.map.getSize()), _this.map.getView().getResolutionForExtent(_this.map.getView().calculateExtent(_this.map.getSize())));
                                })
                            })
                        });
                        break;
                    default:
                        break;
                }
            };
        /**
         * @param {?} configLayer
         * @param {?} source
         * @return {?}
         */
        MapaComponent.prototype.generarLayer = /**
         * @param {?} configLayer
         * @param {?} source
         * @return {?}
         */
            function (configLayer, source$$1) {
                /** @type {?} */
                var styleFunction = this.crearEstilo(configLayer.stylePrefab, configLayer.iconos);
                switch (configLayer.tipoSalida) {
                    case "Vector":
                        if (configLayer.maxResolution) {
                            return new layer.Vector({
                                source: source$$1,
                                visible: configLayer.visible,
                                maxResolution: configLayer.maxResolution,
                                style: styleFunction
                            });
                        }
                        else {
                            return new layer.Vector({
                                source: source$$1,
                                visible: configLayer.visible,
                                style: styleFunction
                            });
                        }
                        break;
                    case "animatedCluster":
                        if (configLayer.maxResolution) {
                            console.log("Se le aplico un max resolution");
                            return new AnimatedCluster({
                                maxResolution: configLayer.maxResolution,
                                source: source$$1,
                                animationDuration: 700,
                                style: styleFunction,
                                visible: configLayer.visible
                            });
                        }
                        else {
                            return new AnimatedCluster({
                                source: source$$1,
                                animationDuration: 700,
                                style: styleFunction,
                                visible: configLayer.visible
                            });
                        }
                        break;
                    case "Tile":
                        if (configLayer.maxResolution) {
                            return new TileLayer({
                                source: source$$1,
                                visible: configLayer.visible,
                                maxResolution: configLayer.maxResolution
                            });
                        }
                        else {
                            return new TileLayer({
                                source: source$$1,
                                visible: configLayer.visible
                            });
                        }
                        break;
                    default:
                        break;
                }
            };
        /**
         * @param {?} features
         * @return {?}
         */
        MapaComponent.prototype.createIntersectionYDiferenciaAutomatica = /**
         * @param {?} features
         * @return {?}
         */
            function (features) {
                var _this = this;
                return new Promise(( /**
                 * @param {?} resolve2
                 * @return {?}
                 */function (resolve2) {
                    /** @type {?} */
                    var parser = new jsts.io.OL3Parser();
                    parser.inject(geom.Point, geom.LineString, LinearRing, Polygon__default, geom.MultiPoint, geom.MultiLineString, geom.MultiPolygon);
                    /** @type {?} */
                    var jstsFeatures = [];
                    // let intersection;
                    features.forEach(( /**
                     * @param {?} feature
                     * @return {?}
                     */function (feature) {
                        console.log("FIGURA >>", feature);
                        /** @type {?} */
                        var jstsGeom = parser.read(feature.getGeometry());
                        jstsFeatures.push(jstsGeom);
                    }));
                    if (jstsFeatures.length == 2) {
                        /** @type {?} */
                        var AB_1 = jstsFeatures[0].intersection(jstsFeatures[1]);
                        _this.insertarFeatureJSTS(parser, AB_1).then(( /**
                         * @param {?} resolve
                         * @return {?}
                         */function (resolve) {
                            console.log(resolve, 'AB');
                            /** @type {?} */
                            var A = jstsFeatures[0].difference(AB_1);
                            _this.insertarFeatureJSTS(parser, A).then(( /**
                             * @param {?} resolve
                             * @return {?}
                             */function (resolve) {
                                console.log(resolve, 'A');
                                /** @type {?} */
                                var B = jstsFeatures[1].difference(AB_1);
                                _this.insertarFeatureJSTS(parser, B).then(( /**
                                 * @param {?} resolve
                                 * @return {?}
                                 */function (resolve) {
                                    console.log(resolve, 'B');
                                    features.forEach(( /**
                                     * @param {?} feature
                                     * @return {?}
                                     */function (feature) { return _this.source.removeFeature(feature); }));
                                    _this.modoInterseccionAutomatica = false;
                                    _this.Intersecciones = [];
                                    resolve2("Se ejecuto createIntersectionYDiferenciaAutomatica Correctamente");
                                }));
                            }));
                        }));
                    }
                    else if (jstsFeatures.length == 3) {
                        /** @type {?} */
                        var AC_1 = jstsFeatures[0].intersection(jstsFeatures[2]);
                        _this.insertarFeatureJSTS(parser, AC_1).then(( /**
                         * @param {?} resolve
                         * @return {?}
                         */function (resolve) {
                            console.log(resolve, "AC");
                            /** @type {?} */
                            var BC = jstsFeatures[1].intersection(jstsFeatures[2]);
                            _this.insertarFeatureJSTS(parser, BC).then(( /**
                             * @param {?} resolve
                             * @return {?}
                             */function (resolve) {
                                console.log(resolve, "BC");
                                /** @type {?} */
                                var AB = jstsFeatures[0].intersection(jstsFeatures[1]);
                                _this.insertarFeatureJSTS(parser, AB).then(( /**
                                 * @param {?} resolve
                                 * @return {?}
                                 */function (resolve) {
                                    console.log(resolve, "AB");
                                    /** @type {?} */
                                    var ABC = jstsFeatures[2].intersection(jstsFeatures[0].intersection(jstsFeatures[1]));
                                    _this.insertarFeatureJSTS(parser, ABC).then(( /**
                                     * @param {?} resolve
                                     * @return {?}
                                     */function (resolve) {
                                        console.log(resolve, "ABC");
                                        /** @type {?} */
                                        var A = jstsFeatures[0].difference(AC_1.union(AB));
                                        _this.insertarFeatureJSTS(parser, A).then(( /**
                                         * @param {?} resolve
                                         * @return {?}
                                         */function (resolve) {
                                            console.log(resolve, "A");
                                            /** @type {?} */
                                            var B = jstsFeatures[1].difference(AB.union(BC));
                                            _this.insertarFeatureJSTS(parser, B).then(( /**
                                             * @param {?} resolve
                                             * @return {?}
                                             */function (resolve) {
                                                console.log(resolve, "B");
                                                /** @type {?} */
                                                var C = jstsFeatures[2].difference(BC.union(AC_1));
                                                _this.insertarFeatureJSTS(parser, C).then(( /**
                                                 * @param {?} resolve
                                                 * @return {?}
                                                 */function (resolve) {
                                                    console.log(resolve, "C");
                                                    features.forEach(( /**
                                                     * @param {?} feature
                                                     * @return {?}
                                                     */function (feature) { return _this.source.removeFeature(feature); }));
                                                    _this.modoInterseccionAutomatica = false;
                                                    _this.Intersecciones = [];
                                                    resolve2("Se ejecuto createIntersectionYDiferenciaAutomatica Correctamente");
                                                }));
                                            }));
                                        }));
                                    }));
                                }));
                            }));
                        }));
                    }
                }));
            };
        /**
         * @param {?} features
         * @return {?}
         */
        MapaComponent.prototype.createIntersection = /**
         * @param {?} features
         * @return {?}
         */
            function (features) {
                var _this = this;
                /** @type {?} */
                var parser = new jsts.io.OL3Parser();
                parser.inject(geom.Point, geom.LineString, LinearRing, Polygon__default, geom.MultiPoint, geom.MultiLineString, geom.MultiPolygon);
                /** @type {?} */
                var jstsFeatures = [];
                // let intersection;
                features.forEach(( /**
                 * @param {?} feature
                 * @return {?}
                 */function (feature) {
                    console.log("FIGURA >>", feature);
                    /** @type {?} */
                    var jstsGeom = parser.read(feature.getGeometry());
                    jstsFeatures.push(jstsGeom);
                }));
                if (jstsFeatures.length == 2) {
                    /** @type {?} */
                    var AB = jstsFeatures[0].intersection(jstsFeatures[1]);
                    this.insertarFeatureJSTS(parser, AB).then(( /**
                     * @param {?} resolve
                     * @return {?}
                     */function (resolve) {
                        console.log(resolve, 'AB');
                        _this.Intersecciones = [];
                    }));
                }
                else if (jstsFeatures.length == 3) {
                    /** @type {?} */
                    var ABC = jstsFeatures[2].intersection(jstsFeatures[0].intersection(jstsFeatures[1]));
                    this.insertarFeatureJSTS(parser, ABC).then(( /**
                     * @param {?} resolve
                     * @return {?}
                     */function (resolve) {
                        console.log(resolve, "ABC");
                        _this.Intersecciones = [];
                    }));
                }
                this.modoInterseccion = false;
            };
        /**
         * @param {?} parser
         * @param {?} featureJSTS
         * @param {?=} source
         * @param {?=} _style
         * @return {?}
         */
        MapaComponent.prototype.insertarFeatureJSTS = /**
         * @param {?} parser
         * @param {?} featureJSTS
         * @param {?=} source
         * @param {?=} _style
         * @return {?}
         */
            function (parser, featureJSTS, source$$1, _style) {
                var _this = this;
                if (source$$1 === void 0) {
                    source$$1 = null;
                }
                if (_style === void 0) {
                    _style = null;
                }
                return new Promise(( /**
                 * @param {?} resolve
                 * @return {?}
                 */function (resolve) {
                    _this.selectedFeatures.clear();
                    /** @type {?} */
                    var feature = new ol.Feature();
                    console.log("featureJSTS", featureJSTS);
                    /** @type {?} */
                    var ObjGeo = parser.write(featureJSTS);
                    if (ObjGeo.getType() == "MultiPolygon") {
                        ObjGeo.getPolygons().forEach(( /**
                         * @param {?} polygon
                         * @return {?}
                         */function (polygon) {
                            _this.insertarFeatureJSTS(parser, parser.read(polygon));
                        }));
                        resolve("Ez");
                        return false;
                    }
                    console.log("OBJETO GEO WKT=>>>>>", ObjGeo);
                    feature.setGeometry(ObjGeo);
                    console.log("Color", _this.color.toString());
                    /** @type {?} */
                    var fill = _this.color.toString();
                    if (fill.startsWith('rgb') || fill.startsWith('rgba')) {
                        /** @type {?} */
                        var cor = _this.color.toString();
                        /** @type {?} */
                        var sbtr = cor.substr(cor.indexOf('(') + 1, cor.indexOf(')') - cor.indexOf('(') - 1);
                        /** @type {?} */
                        var array = sbtr.split(',');
                        /** @type {?} */
                        var a = array[0];
                        /** @type {?} */
                        var b = array[1];
                        /** @type {?} */
                        var c = array[2];
                        fill = "rgba(" + a + "," + b + "," + c + ",0.5)";
                        console.log(fill);
                    }
                    /** @type {?} */
                    var style$$1 = new style.Style({
                        stroke: new style.Stroke({ color: _this.color.toString(), width: 2 }),
                        fill: new style.Fill({ color: fill })
                    });
                    if (_style != null)
                        style$$1 = _style;
                    feature.setStyle(style$$1);
                    /** @type {?} */
                    var CoordsLonlat = [];
                    /** @type {?} */
                    var coordss = ObjGeo.getCoordinates();
                    coordss[0].forEach(( /**
                     * @param {?} coords
                     * @return {?}
                     */function (coords) {
                        /** @type {?} */
                        var lonLat = proj.toLonLat(coords);
                        CoordsLonlat.push(lonLat[0]);
                        CoordsLonlat.push(lonLat[1]);
                    }));
                    if (source$$1 != null)
                        source$$1.addFeature(feature);
                    else
                        _this.source.addFeature(feature);
                    // this.infoBusquedas.push({
                    //   coords:CoordsLonlat,
                    //   type:"Polygon",
                    //   distance:5,
                    //   realizada:false,
                    //   extent:feature.getGeometry().getExtent()
                    // })
                    // this.selectedFeatures.push(feature);
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        resolve("Completado");
                        return feature;
                    }), 250);
                }));
            };
        /**
         * @param {?} features
         * @return {?}
         */
        MapaComponent.prototype.createDiference = /**
         * @param {?} features
         * @return {?}
         */
            function (features) {
                var _this = this;
                /** @type {?} */
                var parser = new jsts.io.OL3Parser();
                parser.inject(geom.Point, geom.LineString, LinearRing, Polygon__default, geom.MultiPoint, geom.MultiLineString, geom.MultiPolygon);
                // this.selectedFeatures.clear();
                if (features.length == 2) {
                    console.log("features .. ", features);
                    /** @type {?} */
                    var jstsGeom = parser.read(features[0].getGeometry());
                    /** @type {?} */
                    var jstsGeom2 = parser.read(features[1].getGeometry());
                    /** @type {?} */
                    var jstsGeomDiference = jstsGeom2.difference(jstsGeom);
                    this.insertarFeatureJSTS(parser, jstsGeomDiference).then(( /**
                     * @return {?}
                     */function () {
                        _this.source.removeFeature(features[1]);
                        _this.modoDiferencia = false;
                        _this.Intersecciones = [];
                    }));
                }
                if (features.length == 3) {
                    /** @type {?} */
                    var jstsGeom1 = parser.read(features[0].getGeometry());
                    /** @type {?} */
                    var jstsGeom2 = parser.read(features[1].getGeometry());
                    /** @type {?} */
                    var jstsGeom3 = parser.read(features[2].getGeometry());
                    /** @type {?} */
                    var jstsGeomDiference = jstsGeom3.difference(jstsGeom1);
                    /** @type {?} */
                    var jstsGeomDiference2_1 = jstsGeom2.difference(jstsGeom3);
                    this.insertarFeatureJSTS(parser, jstsGeomDiference).then(( /**
                     * @return {?}
                     */function () {
                        _this.insertarFeatureJSTS(parser, jstsGeomDiference2_1).then(( /**
                         * @return {?}
                         */function () {
                            // this.source.removeFeature(features[1]);
                            // this.source.removeFeature(features[1]);
                            _this.modoDiferencia = false;
                            _this.Intersecciones = [];
                        }));
                    }));
                }
            };
        /**
         * @param {?} a
         * @return {?}
         */
        MapaComponent.prototype.convertJSTSGeometryPolygonToOL3Polygon = /**
         * @param {?} a
         * @return {?}
         */
            function (a) {
                /**
                 * @param {?} p
                 * @return {?}
                 */
                function p2c(p) {
                    return proj.fromLonLat([p.x, p.y]);
                }
                /** @type {?} */
                var rings = [a._shell._points._coordinates.map(p2c)];
                for (var i = 0; i < a._holes.length; i++) {
                    rings.push(a._holes[i]._points._coordinates.map(p2c));
                }
                /** @type {?} */
                var po = new Polygon__default(rings);
                return po;
            };
        //Procesamiento de datos para crear una inserccion
        //Procesamiento de datos para crear una inserccion
        /**
         * @param {?} map
         * @param {?} This
         * @param {?} container
         * @param {?} overlay
         * @return {?}
         */
        MapaComponent.prototype.eventoClick =
            //Procesamiento de datos para crear una inserccion
            /**
             * @param {?} map
             * @param {?} This
             * @param {?} container
             * @param {?} overlay
             * @return {?}
             */
            function (map, This, container, overlay) {
                map.on('click', ( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) {
                    console.log("click", event);
                    if (This.procesandoFeature) {
                        This.selectedFeatures.clear();
                        return;
                    }
                    if (This.utilizandoPopUp == false)
                        container.innerHTML = "";
                    else
                        This.utilizandoPopUp = true;
                    This.Intersecciones = [];
                    //Si en este loop tiene mas de dos feature entra a interseccion.
                    map.forEachFeatureAtPixel(event.pixel, ( /**
                     * @param {?} feature
                     * @param {?} layer
                     * @return {?}
                     */function (feature, layer$$1) {
                        // if(This.modoInterseccionAutomatica || This.modoInterseccion || This.modoDiferencia){
                        // console.log(feature);
                        if (feature.getGeometry().getType() == "Polygon") {
                            This.Intersecciones.push(feature);
                            console.log(This.Intersecciones);
                        }
                        // }
                    }));
                    if (This.Intersecciones.length > 1) {
                        // setTimeout(() => {
                        This.procesandoFeature = true;
                        This.createIntersectionYDiferenciaAutomatica(This.Intersecciones).then(( /**
                         * @param {?} resolve
                         * @return {?}
                         */function (resolve) {
                            console.log(resolve);
                            This.procesandoFeature = false;
                        }));
                        // }, 1000);
                    }
                    if (This.modoInterseccionAutomatica) {
                        setTimeout(( /**
                         * @return {?}
                         */function () {
                            This.createIntersectionYDiferenciaAutomatica(This.Intersecciones);
                        }), 1000);
                    }
                    if (This.modoInterseccion) {
                        setTimeout(( /**
                         * @return {?}
                         */function () {
                            This.createIntersection(This.Intersecciones);
                        }), 1000);
                    }
                    if (This.modoDiferencia) {
                        This.createDiference(This.Intersecciones);
                    }
                    else if (This.Intersecciones.length > 3) {
                        This.Intersecciones = [];
                    }
                }));
            };
        /**
         * @param {?} Coordenadas
         * @param {?} Tipo
         * @param {?} Distance
         * @param {?} extent
         * @return {?}
         */
        MapaComponent.prototype.busquedaGeo = /**
         * @param {?} Coordenadas
         * @param {?} Tipo
         * @param {?} Distance
         * @param {?} extent
         * @return {?}
         */
            function (Coordenadas, Tipo, Distance, extent$$1) {
                if (this.utilizandoPopUp) {
                    this.utilizandoPopUp = false;
                }
                this.content.innerHTML = "";
                /** @type {?} */
                var Layers = this.map.getLayerGroup();
                /** @type {?} */
                var a = 1000;
                Layers.getLayersArray().forEach(( /**
                 * @param {?} element
                 * @return {?}
                 */function (element) {
                    element.setZIndex(a);
                    a++;
                }));
                /** @type {?} */
                var centro;
                /** @type {?} */
                var coords = Coordenadas || [-120.0146484375, 32.805744732906874, -120.0146484375, 12.082295837363588, -82.529296875, 12.082295837363588, -82.529296875, 32.805744732906874, -120.0146484375, 32.805744732906874];
                Tipo = Tipo || 'Rectangle';
                // centro pensando que siempre es un cuadrado
                /** @type {?} */
                var p1 = [coords[0], coords[1]];
                /** @type {?} */
                var p2 = [coords[4], coords[5]];
                centro = this.calcularPuntoMedio(p1, p2);
                /** @type {?} */
                var Coords3 = coords;
                /** @type {?} */
                var Coords4 = [];
                for (var index = 0; index < Coords3.length; index += 2) {
                    Coords4 = proj.toLonLat([Coords3[index], Coords3[index + 1]]);
                }
                if (Distance == undefined) {
                    Distance = 5;
                }
                if (Tipo != 'Rectangle') {
                    Coords4 = coords;
                    centro = proj.fromLonLat(centro);
                }
                else if (Tipo == 'Rectangle') ;
                else if (Tipo == 'Circle') {
                    centro = proj.fromLonLat(Coordenadas);
                }
                if (Coords4[0] > 0 && Coords4[0] < 1 || Coords4[0] < 0 && Coords4[0] > -1) {
                    Coords4 = coords;
                    centro = proj.fromLonLat(centro);
                }
                if (isNaN(centro[0])) {
                    centro = proj.fromLonLat(Coordenadas);
                }
                this.coordenadasActual = Coords4;
                // this.cursorOriginal();
                this.map.removeInteraction(this.draw);
                /** @type {?} */
                var polygonWKT = "POLYGON ((";
                /** @type {?} */
                var coordsX = [];
                /** @type {?} */
                var coordsY = [];
                /** @type {?} */
                var b = 1;
                for (var index = 0; index < Coords4.length; index++) {
                    if (b == 1) {
                        coordsX.push(Coords4[index]);
                        b++;
                    }
                    else if (b == 2) {
                        coordsY.push(Coords4[index]);
                        b = 1;
                    }
                }
                for (var i = 0; i < coordsX.length; i++) {
                    polygonWKT += coordsX[i] + " " + coordsY[i] + ",";
                }
                polygonWKT = polygonWKT.slice(0, polygonWKT.length - 1);
                polygonWKT += "))";
                console.log(polygonWKT);
                //intersectsCoordinate(coordinate)
                this.figurasActivas.push(polygonWKT);
                this.spinner.hide();
                // this.consultarV2();
            };
        /**
         * @param {?} selectedFeatures
         * @param {?} This
         * @return {?}
         */
        MapaComponent.prototype.selectedOn = /**
         * @param {?} selectedFeatures
         * @param {?} This
         * @return {?}
         */
            function (selectedFeatures, This) {
                selectedFeatures.on(['add'], ( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) {
                    var _this = this;
                    console.log("This.paginacionGeo.geometrysWKT", This.paginacionGeo.geometrysWKT);
                    console.log("This.paginacionGeo.UUID", This.paginacionGeo.UUID);
                    /** @type {?} */
                    var tiposOrigen = "";
                    This.tiposOrigenes.forEach(( /**
                     * @param {?} tipo
                     * @return {?}
                     */function (tipo) {
                        if (tipo != null) {
                            tiposOrigen += "tipoOrigen=" + tipo + ";";
                        }
                    }));
                    tiposOrigen = tiposOrigen.slice(0, tiposOrigen.length - 1);
                    This.paginacionGeo.tipoOrigen = tiposOrigen;
                    // if(This.teclaPresionada=="Control"){
                    //   This.featuresSeleccionados.push(event['element'])
                    //   This.selectedFeatures.clear();
                    //   This.featuresSeleccionados.forEach(feature => {
                    //     This.selectedFeatures.push(feature);
                    //   });
                    // }
                    console.log(event);
                    /** @type {?} */
                    var ObjectGeo = event['element'].getGeometry();
                    if (ObjectGeo.getType() == "Polygon" || ObjectGeo.getType() == "Circle") {
                        return;
                    }
                    else {
                        if (ObjectGeo.getType() == "Point") {
                            //Tipo Resultado Detalle
                            /** @type {?} */
                            var polygon = event['element'].values_.polygon;
                            if (polygon === undefined) {
                                try {
                                    polygon = event['element'].values_.features[0].values_.polygon;
                                }
                                catch (_a) {
                                    console.log("Error al querer extraer informacion de un feature clusterizado...");
                                }
                            }
                            if (polygon != undefined) {
                                This.paginacionGeo.geometrysWKT = [polygon];
                            }
                            else {
                                This.paginacionGeo.geometrysWKT = null;
                                /** @type {?} */
                                var UUID = event['element'].values_.UUID;
                                /** @type {?} */
                                var UUIDS_1 = [];
                                if (UUID === undefined) {
                                    event['element'].values_.features.forEach(( /**
                                     * @param {?} element
                                     * @return {?}
                                     */function (element) {
                                        if (element.values_.UUID) {
                                            UUIDS_1.push(element.values_.UUID);
                                        }
                                    }));
                                    //  UUID = event['element'].values_.features[0].values_.UUID;
                                }
                                This.paginacionGeo.UUID = UUIDS_1;
                            }
                            if (This.paginacionGeo.geometrysWKT || This.paginacionGeo.UUID.length > 0) {
                                console.log("Polygon Seleccionado", event['element']);
                                This.paginacionGeo.tipoOrigen = tiposOrigen;
                                This.paginacionGeo.pagActual = 1;
                                This.buscarDetalle();
                            }
                            else {
                                /** @type {?} */
                                var features_1 = event['element'].values_.features;
                                if (features_1 === undefined) {
                                    return;
                                }
                                if (features_1.length > 30)
                                    This.spinner.show();
                                setTimeout(( /**
                                 * @return {?}
                                 */function () {
                                    features_1.forEach(( /**
                                     * @param {?} feature
                                     * @return {?}
                                     */function (feature) {
                                        console.log(feature);
                                        // console.log(feature.values_.data);
                                        if (feature.values_.header === undefined) {
                                            // console.log(feature);
                                            return;
                                        }
                                        /** @type {?} */
                                        var header = feature.values_.header;
                                        if (typeof (header) == "object") {
                                            header = Object.values(header)[0];
                                        }
                                        console.log(header);
                                        This.llenarPopUp(header, feature, features_1);
                                        if (This.content.innerHTML != "") {
                                            console.log(event);
                                            This.overlay.setPosition(event.element.getGeometry().getCoordinates());
                                            _this.utilizandoPopUp = false;
                                        }
                                        if (features_1.length > 30)
                                            This.spinner.hide();
                                    }));
                                }), 100);
                            }
                        }
                    }
                }));
            };
        /**
         * @param {?} draw
         * @param {?} source
         * @param {?} map
         * @param {?} overlay
         * @param {?} content
         * @param {?} selectedFeatures
         * @param {?} THIS
         * @param {?} hole
         * @return {?}
         */
        MapaComponent.prototype.drawOnEvent = /**
         * @param {?} draw
         * @param {?} source
         * @param {?} map
         * @param {?} overlay
         * @param {?} content
         * @param {?} selectedFeatures
         * @param {?} THIS
         * @param {?} hole
         * @return {?}
         */
            function (draw, source$$1, map, overlay, content, selectedFeatures, THIS, hole) {
                draw.on('drawstart', ( /**
                 * @param {?} evt
                 * @return {?}
                 */function (evt) {
                    console.log(evt.feature);
                    console.log("Color", THIS.color.toString());
                    /** @type {?} */
                    var fill = THIS.color.toString();
                    if (fill.startsWith('rgb') || fill.startsWith('rgba')) {
                        /** @type {?} */
                        var cor = THIS.color.toString();
                        /** @type {?} */
                        var sbtr = cor.substr(cor.indexOf('(') + 1, cor.indexOf(')') - cor.indexOf('(') - 1);
                        /** @type {?} */
                        var array = sbtr.split(',');
                        /** @type {?} */
                        var a = array[0];
                        /** @type {?} */
                        var b = array[1];
                        /** @type {?} */
                        var c = array[2];
                        fill = "rgba(" + a + "," + b + "," + c + ",0.5)";
                        console.log(fill);
                    }
                    /** @type {?} */
                    var style$$1 = new style.Style({
                        stroke: new style.Stroke({ color: THIS.color.toString(), width: 2 }),
                        fill: new style.Fill({ color: fill })
                    });
                    evt.feature.setStyle(style$$1);
                    // var coordinate=evt.feature.getGeometry().getFirstCoordinate();
                    /** @type {?} */
                    var coordinate = [evt.feature.getGeometry()['flatCoordinates'][0], evt.feature.getGeometry()['flatCoordinates'][1]];
                    hole = map.forEachFeatureAtPixel(map.getPixelFromCoordinate(coordinate), ( /**
                     * @param {?} feature
                     * @return {?}
                     */function (feature) {
                        if ('Polygon' == feature.getGeometry().getType()) {
                            return feature;
                        }
                    }));
                }));
                draw.on('drawend', ( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) {
                    if (hole) {
                        /** @type {?} */
                        var coordinates = [event.feature.getGeometry()['flatCoordinates'][0], event.feature.getGeometry()['flatCoordinates'][1]];
                        console.log(coordinates);
                        hole.getGeometry().appendLinearRing(new LinearRing(coordinates));
                    }
                    console.log("Extent de la figura", event.feature.getGeometry().getExtent());
                    console.log("Color", THIS.color.toString());
                    /** @type {?} */
                    var fill = THIS.color.toString();
                    if (fill.startsWith('rgb') || fill.startsWith('rgba')) {
                        /** @type {?} */
                        var cor = THIS.color.toString();
                        /** @type {?} */
                        var sbtr = cor.substr(cor.indexOf('(') + 1, cor.indexOf(')') - cor.indexOf('(') - 1);
                        /** @type {?} */
                        var array = sbtr.split(',');
                        /** @type {?} */
                        var a = array[0];
                        /** @type {?} */
                        var b = array[1];
                        /** @type {?} */
                        var c = array[2];
                        fill = "rgba(" + a + "," + b + "," + c + ",0.5)";
                        console.log(fill);
                    }
                    /** @type {?} */
                    var style$$1 = new style.Style({
                        stroke: new style.Stroke({ color: THIS.color.toString(), width: 2 }),
                        fill: new style.Fill({ color: fill })
                    });
                    console.log("Draw Style", style$$1);
                    event.feature.setStyle(style$$1);
                    // document.documentElement.style.cursor='default';
                    /** @type {?} */
                    var Distance = 5;
                    /** @type {?} */
                    var Type;
                    /** @type {?} */
                    var Coords3;
                    Type = event['feature'].getGeometry().getType();
                    Coords3 = event['feature'].getGeometry()['flatCoordinates'];
                    /** @type {?} */
                    var Dibujar = true;
                    switch (Type) {
                        case "Polygon":
                            Coords3 = event['feature'].getGeometry()['flatCoordinates'];
                            break;
                        case "Circle":
                            /** @type {?} */
                            var newCircle = event.feature.getGeometry();
                            /** @type {?} */
                            var featureFromCircle = Polygon.fromCircle(newCircle);
                            /** @type {?} */
                            var feature = new ol.Feature(featureFromCircle);
                            Coords3 = [];
                            /** @type {?} */
                            var Coords = featureFromCircle.getCoordinates();
                            Coords[0].forEach(( /**
                             * @param {?} coords
                             * @return {?}
                             */function (coords) {
                                /** @type {?} */
                                var coordsTmp = proj.toLonLat(coords);
                                // console.log(coordsTmp);
                                Coords3.push(coordsTmp[0]);
                                Coords3.push(coordsTmp[1]);
                            }));
                            if (THIS.tipoCirculo == 2) {
                                /** @type {?} */
                                var center = newCircle.getCenter();
                                /** @type {?} */
                                var Radius_1 = newCircle.getRadius();
                                // newCircl
                                /** @type {?} */
                                var top_1 = [center[0], center[1] + Radius_1];
                                // console.log("Distancia",Radius);
                                /** @type {?} */
                                var lineN = new geom.LineString([[center[0], center[1]], [top_1[0], top_1[1]], [center[0], center[1]]]);
                                /** @type {?} */
                                var lineSE = new geom.LineString([[center[0], center[1]], [top_1[0], top_1[1]], [center[0], center[1]]]);
                                /** @type {?} */
                                var lineSO = new geom.LineString([[center[0], center[1]], [top_1[0], top_1[1]], [center[0], center[1]]]);
                                // let lineS = new LineString([[center[0],center[1]],[bot[0],bot[1]],[center[0],center[1]]]);
                                lineSE.rotate(2.0944, center);
                                lineSO.rotate(4.18879, center);
                                /** @type {?} */
                                var parser = new jsts.io.OL3Parser();
                                parser.inject(geom.Point, geom.LineString, LinearRing, Polygon__default, geom.MultiPoint, geom.MultiLineString, geom.MultiPolygon);
                                /** @type {?} */
                                var jstsGeom = parser.read(featureFromCircle);
                                /** @type {?} */
                                var jstsGeom2 = parser.read(lineN);
                                /** @type {?} */
                                var jstsGeom3 = parser.read(lineSE);
                                /** @type {?} */
                                var jstsGeom4 = parser.read(lineSO);
                                /** @type {?} */
                                var jstsGeomUnion = jstsGeom4.union(jstsGeom2.union(jstsGeom3));
                                /** @type {?} */
                                var union = jstsGeom.getExteriorRing().union(jstsGeomUnion);
                                /** @type {?} */
                                var polygonizer = new jsts.operation.polygonize.Polygonizer();
                                polygonizer.add(union);
                                /** @type {?} */
                                var polygons = polygonizer.getPolygons();
                                for (var i = polygons.iterator(); i.hasNext();) {
                                    /** @type {?} */
                                    var polygon = i.next();
                                    THIS.insertarFeatureJSTS(parser, polygon);
                                }
                                // THIS.source.addFeature(new Feature(lineN));
                                // THIS.source.addFeature(new Feature(lineSE));
                                // THIS.source.addFeature(new Feature(lineSO));
                            }
                            else {
                                console.log("Ento a insertar circulo completo");
                                /** @type {?} */
                                var fill_1 = THIS.color.toString();
                                if (fill_1.startsWith('rgb') || fill_1.startsWith('rgba')) {
                                    /** @type {?} */
                                    var cor = THIS.color.toString();
                                    /** @type {?} */
                                    var sbtr = cor.substr(cor.indexOf('(') + 1, cor.indexOf(')') - cor.indexOf('(') - 1);
                                    /** @type {?} */
                                    var array = sbtr.split(',');
                                    /** @type {?} */
                                    var a = array[0];
                                    /** @type {?} */
                                    var b = array[1];
                                    /** @type {?} */
                                    var c = array[2];
                                    fill_1 = "rgba(" + a + "," + b + "," + c + ",0.5)";
                                    console.log(fill_1);
                                }
                                /** @type {?} */
                                var style_7 = new style.Style({
                                    stroke: new style.Stroke({ color: THIS.color.toString(), width: 2 }),
                                    fill: new style.Fill({ color: fill_1 })
                                });
                                feature.setStyle(style_7);
                                THIS.source.addFeature(feature);
                            }
                            setTimeout(( /**
                             * @return {?}
                             */function () {
                                THIS.source.removeFeature(event.feature);
                            }), 200);
                            THIS.infoBusquedas.push({
                                coords: Coords3,
                                type: 'Polygon',
                                distance: 5,
                                realizada: false,
                                extent: featureFromCircle.getExtent()
                            });
                            THIS.cursorOriginal();
                            THIS.map.removeInteraction(THIS.draw);
                            // let distancia = getDistance(toLonLat(Coords3),toLonLat(coords));
                            // Distance =    (Math.round(distancia / 1000 * 100) / 100);
                            break;
                        case "Rectangle":
                            break;
                        case "Point":
                            console.log("Type", Type);
                            console.log("tipoCirculo", THIS.tipoCirculo);
                            Dibujar = false;
                            /** @type {?} */
                            var Radius_2;
                            // let Type; 
                            /** @type {?} */
                            var Coords4_1 = [];
                            THIS.utilizandoPopUp = true;
                            THIS.content.innerHTML = "<div><label>Radio</label>\n          <input type='text' id='input'>\n          <select id=\"typeDistance\">\n            <option value=\"metros\">Metros</option>\n            <option value=\"millas\">Millas</option>\n            <option value=\"kilometros\">Kilometros</option>\n          </select>\n          <button id='btnPopupAceptar'>Aceptar</button>\n          </div>";
                            overlay.setPosition(event['feature'].getGeometry()['flatCoordinates']);
                            document.getElementById('btnPopupAceptar').onclick = ( /**
                             * @return {?}
                             */function () {
                                source$$1.removeFeature(event['feature']);
                                /** @type {?} */
                                var distance = document.getElementById('input');
                                document.getElementById('scroll').scrollTo(0, 0);
                                overlay.setPosition(undefined);
                                /** @type {?} */
                                var LayersArray = map.getLayerGroup().getLayers();
                                Radius_2 = parseFloat(distance['value']);
                                /** @type {?} */
                                var Option = document.getElementById('typeDistance');
                                if (Option['value'] == 'millas') {
                                    Radius_2 = Radius_2 * 1609.34;
                                }
                                else if (Option['value'] == 'kilometros') {
                                    Radius_2 = Radius_2 * 1000;
                                }
                                /** @type {?} */
                                var NewCircle = new geom.Circle(event['feature'].getGeometry()['flatCoordinates'], Radius_2);
                                /** @type {?} */
                                var circlePolygon = Polygon.fromCircle(NewCircle);
                                Type = circlePolygon.getType();
                                /** @type {?} */
                                var Coords3;
                                Coords3 = circlePolygon['flatCoordinates'];
                                // Coords3=NewCircle.getCenter();
                                // let coords = NewCircle.getLastCoordinate();
                                // let distancia = getDistance(toLonLat(Coords3),toLonLat(coords));
                                if (THIS.tipoCirculo == 2) {
                                    /** @type {?} */
                                    var center = NewCircle.getCenter();
                                    /** @type {?} */
                                    var top_2 = [center[0], center[1] + Radius_2];
                                    console.log("Distancia", Radius_2);
                                    /** @type {?} */
                                    var lineN = new geom.LineString([[center[0], center[1]], [top_2[0], top_2[1]], [center[0], center[1]]]);
                                    /** @type {?} */
                                    var lineSE = new geom.LineString([[center[0], center[1]], [top_2[0], top_2[1]], [center[0], center[1]]]);
                                    /** @type {?} */
                                    var lineSO = new geom.LineString([[center[0], center[1]], [top_2[0], top_2[1]], [center[0], center[1]]]);
                                    // let lineS = new LineString([[center[0],center[1]],[bot[0],bot[1]],[center[0],center[1]]]);
                                    lineSE.rotate(2.0944, center);
                                    lineSO.rotate(4.18879, center);
                                    /** @type {?} */
                                    var parser = new jsts.io.OL3Parser();
                                    parser.inject(geom.Point, geom.LineString, LinearRing, Polygon__default, geom.MultiPoint, geom.MultiLineString, geom.MultiPolygon);
                                    /** @type {?} */
                                    var jstsGeom = parser.read(circlePolygon);
                                    /** @type {?} */
                                    var jstsGeom2 = parser.read(lineN);
                                    /** @type {?} */
                                    var jstsGeom3 = parser.read(lineSE);
                                    /** @type {?} */
                                    var jstsGeom4 = parser.read(lineSO);
                                    /** @type {?} */
                                    var jstsGeomUnion = jstsGeom4.union(jstsGeom2.union(jstsGeom3));
                                    /** @type {?} */
                                    var union = jstsGeom.getExteriorRing().union(jstsGeomUnion);
                                    /** @type {?} */
                                    var polygonizer = new jsts.operation.polygonize.Polygonizer();
                                    polygonizer.add(union);
                                    /** @type {?} */
                                    var polygons = polygonizer.getPolygons();
                                    for (var i = polygons.iterator(); i.hasNext();) {
                                        /** @type {?} */
                                        var polygon = i.next();
                                        THIS.insertarFeatureJSTS(parser, polygon);
                                    }
                                    // THIS.source.addFeature(new Feature(lineN));
                                    // THIS.source.addFeature(new Feature(lineSE));
                                    // THIS.source.addFeature(new Feature(lineSO));
                                }
                                else {
                                    /** @type {?} */
                                    var feature_1 = new ol.Feature({
                                        geometry: circlePolygon,
                                        feature: 'Generic Name'
                                    });
                                    /** @type {?} */
                                    var fill_2 = THIS.color.toString();
                                    if (fill_2.startsWith('rgb') || fill_2.startsWith('rgba')) {
                                        /** @type {?} */
                                        var cor = THIS.color.toString();
                                        /** @type {?} */
                                        var sbtr = cor.substr(cor.indexOf('(') + 1, cor.indexOf(')') - cor.indexOf('(') - 1);
                                        /** @type {?} */
                                        var array = sbtr.split(',');
                                        /** @type {?} */
                                        var a = array[0];
                                        /** @type {?} */
                                        var b = array[1];
                                        /** @type {?} */
                                        var c = array[2];
                                        fill_2 = "rgba(" + a + "," + b + "," + c + ",0.2)";
                                        console.log(fill_2);
                                    }
                                    /** @type {?} */
                                    var style_8 = new style.Style({
                                        stroke: new style.Stroke({ color: THIS.color.toString(), width: 2 }),
                                        fill: new style.Fill({ color: fill_2 })
                                    });
                                    feature_1.setStyle(style_8);
                                    LayersArray.getArray()[2]['values_']['source'].addFeature(feature_1);
                                }
                                // Distance = (Math.round(distancia / 1000 * 100) / 100);
                                Coords4_1 = [];
                                /** @type {?} */
                                var ar;
                                for (var index = 0; index < Coords3.length; index++) {
                                    ar = proj.toLonLat([Coords3[index], Coords3[index + 1]]);
                                    index = index + 1;
                                    ar.forEach(( /**
                                     * @param {?} element
                                     * @return {?}
                                     */function (element) {
                                        Coords4_1.push(element);
                                    }));
                                }
                                // selectedFeatures.clear();  
                                THIS.infoBusquedas.push({
                                    coords: Coords4_1,
                                    type: Type,
                                    distance: 5,
                                    realizada: false,
                                    extent: circlePolygon.getExtent()
                                });
                                THIS.cursorOriginal();
                                THIS.map.removeInteraction(THIS.draw);
                                // THIS.busquedaGeo(Coords4,Type,Distance,false)   
                            });
                            // ClusterSource.getSource().removeFeature(event['feature']);
                            break;
                        case "LineString":
                            Coords3 = event['feature'].getGeometry()['flatCoordinates'];
                            if (Coords3.length > 4) {
                                Type = "Polygon";
                            }
                            break;
                        default:
                            break;
                    }
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        THIS.selectedFeatures.clear();
                    }), 300);
                    if (Dibujar) {
                        /** @type {?} */
                        var Coords4_2 = [];
                        /** @type {?} */
                        var ar = void 0;
                        for (var index = 0; index < Coords3.length; index++) {
                            ar = proj.toLonLat([Coords3[index], Coords3[index + 1]]);
                            index = index + 1;
                            ar.forEach(( /**
                             * @param {?} element
                             * @return {?}
                             */function (element) {
                                Coords4_2.push(element);
                            }));
                        }
                        // source.getFeatures().forEach(element=>{
                        //   source.removeFeature(element);
                        // })  
                        if (Type == "Circle")
                            return;
                        THIS.infoBusquedas.push({
                            coords: Coords4_2,
                            type: Type,
                            distance: Distance,
                            realizada: false,
                            extent: event['feature'].getGeometry().getExtent()
                        });
                        console.log("InfoBusquedas", THIS.infoBusquedas);
                        // console.log(event['feature']);
                        // setTimeout(() => {
                        //   THIS.source.removeFeature(event['feature']);
                        // }, 1000);
                    }
                    THIS.cursorOriginal();
                    THIS.map.removeInteraction(THIS.draw);
                }));
            };
        /**
         * @param {?} tipoDibujo
         * @return {?}
         */
        MapaComponent.prototype.addDraw = /**
         * @param {?} tipoDibujo
         * @return {?}
         */
            function (tipoDibujo) {
                /** @type {?} */
                var fill = this.color.toString();
                if (fill.startsWith('rgb') || fill.startsWith('rgba')) {
                    /** @type {?} */
                    var cor = this.color.toString();
                    /** @type {?} */
                    var sbtr = cor.substr(cor.indexOf('(') + 1, cor.indexOf(')') - cor.indexOf('(') - 1);
                    /** @type {?} */
                    var array = sbtr.split(',');
                    /** @type {?} */
                    var a = array[0];
                    /** @type {?} */
                    var b = array[1];
                    /** @type {?} */
                    var c = array[2];
                    fill = "rgba(" + a + "," + b + "," + c + ",0.5)";
                    console.log(fill);
                }
                /** @type {?} */
                var style$$1 = new style.Style({
                    stroke: new style.Stroke({ color: this.color.toString(), width: 2 }),
                    fill: new style.Fill({ color: fill })
                });
                console.log("Style actual", style$$1);
                this.draw = new interaction.Draw({
                    source: this.source,
                    type: tipoDibujo,
                    style: style$$1
                });
                this.map.addInteraction(this.draw);
                this.cursorCruz();
            };
        /**
         * @param {?} clos
         * @param {?} Selecteddfeatures
         * @param {?} overlay
         * @param {?} THIS
         * @return {?}
         */
        MapaComponent.prototype.cerrarPopup = /**
         * @param {?} clos
         * @param {?} Selecteddfeatures
         * @param {?} overlay
         * @param {?} THIS
         * @return {?}
         */
            function (clos, Selecteddfeatures, overlay, THIS) {
                clos.onclick = ( /**
                 * @return {?}
                 */function () {
                    THIS.utilizandoPopUp = false;
                    document.getElementById('scroll').scrollTo(0, 0);
                    overlay.setPosition(undefined);
                    clos.blur();
                    // Selecteddfeatures.clear();
                    return false;
                });
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.cerrarPopUpV2 = /**
         * @return {?}
         */
            function () {
                if (this.showOption)
                    this.showOption = false;
                this.ocultarClickDerechoMenu();
                if (!this.utilizandoPopUp) {
                    // if(this.overlay.
                    // )
                    if (this.overlay.getPosition() != undefined) {
                        // document.getElementById('scroll').scrollTo(0,0);
                        this.overlay.setPosition(undefined);
                        this.closer.blur();
                        // this.selectedFeatures.clear();
                    }
                }
            };
        /**
         * @param {?} stringUTC
         * @return {?}
         */
        MapaComponent.prototype.UTCaLocal = /**
         * @param {?} stringUTC
         * @return {?}
         */
            function (stringUTC) {
                /** @type {?} */
                var fecha = Date.parse(stringUTC);
                /** @type {?} */
                var fechaUTC = new Date(fecha);
                /** @type {?} */
                var offset = fechaUTC.getTimezoneOffset() * 60000;
                /** @type {?} */
                var milisegundos = fechaUTC.getTime() - offset;
                return new Date(milisegundos);
            };
        /**
         * @param {?} map
         * @param {?} selectedFeatures
         * @return {?}
         */
        MapaComponent.prototype.eventDoubleClick = /**
         * @param {?} map
         * @param {?} selectedFeatures
         * @return {?}
         */
            function (map, selectedFeatures) {
                map.on('dblclick', ( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) {
                    // selectedFeatures.clear();
                    /** @type {?} */
                    var features = [];
                    map.forEachFeatureAtPixel(event.pixel, ( /**
                     * @param {?} feature
                     * @param {?} Layer
                     * @return {?}
                     */function (feature, Layer) {
                        features = feature['values_']['features'];
                        /** @type {?} */
                        var extent$$1 = extent.createEmpty();
                        if (features) {
                            features.forEach(( /**
                             * @param {?} f
                             * @param {?} index
                             * @param {?} array
                             * @return {?}
                             */function (f, index, array) {
                                extent.extend(extent$$1, f.getGeometry().getExtent());
                            }));
                            map.getView().fit(extent$$1);
                        }
                    }));
                }));
            };
        /**
         * @param {?} map
         * @return {?}
         */
        MapaComponent.prototype.desactivarZoomDobleClick = /**
         * @param {?} map
         * @return {?}
         */
            function (map) {
                /** @type {?} */
                var dblClickInteraction;
                map.getInteractions().getArray().forEach(( /**
                 * @param {?} interaction
                 * @return {?}
                 */function (interaction$$1) {
                    if (interaction$$1 instanceof interaction.DoubleClickZoom) {
                        dblClickInteraction = interaction$$1;
                    }
                }));
                map.removeInteraction(dblClickInteraction);
            };
        /**
         * @param {?} clusterSource
         * @return {?}
         */
        MapaComponent.prototype.ajustarZoom = /**
         * @param {?} clusterSource
         * @return {?}
         */
            function (clusterSource) {
                /** @type {?} */
                var originalFeatures = clusterSource.getSource().getFeatures();
                /** @type {?} */
                var extent$$1 = extent.createEmpty();
                originalFeatures.forEach(( /**
                 * @param {?} f
                 * @param {?} index
                 * @param {?} array
                 * @return {?}
                 */function (f, index, array) {
                    extent.extend(extent$$1, f.getGeometry().getExtent());
                }));
                this.map.getView().fit(extent$$1);
            };
        /**
         * @param {?} fecha
         * @param {?} tipo
         * @return {?}
         */
        MapaComponent.prototype.obtenerFechaFormateada = /**
         * @param {?} fecha
         * @param {?} tipo
         * @return {?}
         */
            function (fecha, tipo) {
                // console.log(fecha)
                if (fecha.month == undefined || fecha.day == undefined || fecha.year == undefined) {
                    // 2019-03-04T16:59:45Z
                    /** @type {?} */
                    var day_1 = fecha.substr(8, 2);
                    /** @type {?} */
                    var month_1 = fecha.substr(5, 2);
                    /** @type {?} */
                    var year_1 = fecha.substr(0, 4);
                    return day_1 + "/" + month_1 + "/" + year_1;
                }
                /** @type {?} */
                var month = fecha['month'];
                // month = month < 10 ? '0'+ month: month + "";
                /** @type {?} */
                var day = fecha['day'];
                /** @type {?} */
                var year = fecha['year'];
                console.log(year + "/" + month + "/" + day);
                if (tipo)
                    return year + "-" + (month < 10 ? '0' + month : month) + "-" + (day < 10 ? '0' + day : day) + (tipo == 1 ? 'T00:00:00Z' : 'T23:59:00Z');
                if (!tipo)
                    return year + "-" + (month < 10 ? '0' + month : month) + "-" + (day < 10 ? '0' + day : day);
            };
        /**
         * @param {?} obj
         * @return {?}
         */
        MapaComponent.prototype.funcionesMenu = /**
         * @param {?} obj
         * @return {?}
         */
            function (obj) {
                switch (obj) {
                    // ********** MAPAS ***************
                    case 'OSM':
                        this.googleLayer.setVisible(false);
                        this.OSMLayer.setVisible(true);
                        break;
                    case 'Google':
                        this.OSMLayer.setVisible(false);
                        this.googleLayer.setVisible(true);
                        break;
                    case 'mapCalor':
                        console.log("Maapa Calor Activado!!!!");
                        this.statusMapaCalor = true;
                        this.consultarV2();
                        // this.mapaCalorActivo=true;
                        break;
                    case 'mapPuntos':
                        console.log("Mapa Puntos Activado!!!!");
                        this.statusMapaCalor = false;
                        this.consultarV2();
                        // this.mapaCalorActivo=false;
                        break;
                    // ********** TIPOS DE DIBUJO ***************      
                    default:
                        console.log(this.map.getInteractions());
                        switch (obj) {
                            case 'Circle': //Circulo normal
                                this.tipoSeleccionado = obj;
                                this.tipoCirculo = 0;
                                break;
                            case 'circleOpt1': //Circulo normal x medidas
                                this.tipoSeleccionado = 'Point';
                                this.tipoCirculo = 1;
                                break;
                            case 'circleOpt2': //Circulo dividido x medidas
                                this.tipoSeleccionado = 'Point';
                                this.tipoCirculo = 2;
                                break;
                            case 'circleOpt3': //Circulo dividido
                                this.tipoSeleccionado = 'Circle';
                                this.tipoCirculo = 2;
                                break;
                            case 'Polygon': //poligono
                                this.tipoSeleccionado = 'Polygon';
                                this.tipoCirculo = 0;
                                break;
                            default:
                                break;
                        }
                        if (this.draw)
                            this.map.removeInteraction(this.draw);
                        this.addDraw(this.tipoSeleccionado);
                        this.drawOnEvent(this.draw, this.source, this.map, this.overlay, this.content, this.selectedFeatures, this, this.hole);
                        break;
                }
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.eliminarTodo = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.buscando = false;
                this.isCollapsedR = true;
                this.chkActualizarResult = false;
                this.buscarArea.nativeElement.style.display = "none";
                this.labelActualizar.nativeElement.style.display = "none";
                this.busquedaTextoLayer.getSource().getSource().clear();
                this.busquedaClusterLayer.getSource().getSource().clear();
                this.busquedaFacetLayer.getSource().clear();
                this.mapaCalor.getSource().clear();
                this.figurasActivas = [];
                this.Intersecciones = [];
                this.totalEncontrados = 0;
                this.infoBusquedas = [];
                this.source.getFeatures().forEach(( /**
                 * @param {?} figura
                 * @return {?}
                 */function (figura) {
                    _this.source.removeFeature(figura);
                }));
                this.busquedasActuales.forEach(( /**
                 * @param {?} busquedas
                 * @return {?}
                 */function (busquedas) {
                    busquedas.cluster.getSource().clear(true);
                }));
                // this.arregloCapas.forEach(capa=>{
                //   capa.cluster.getSource().getSource().getFeatures().forEach(Feature=>{
                //     capa.cluster.getSource().getSource().removeFeature(Feature);
                //   })
                // // this.clusterSource.getSource().addFeature(feature);
                // })
                this.selectCluster.clear();
                // this.selectedFeatures.clear();
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.eliminarSeleccionado = /**
         * @return {?}
         */
            function () {
                this.ocultarClickDerechoMenu();
                if (this.selectedFeatures['array_'][0]) {
                    console.log("Se eliminó >>>", this.selectedFeatures['array_'][0]);
                    this.source.removeFeature(this.selectedFeatures['array_'][0]);
                    this.selectedFeatures.clear();
                }
                this.consultarV2();
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.cursorCruz = /**
         * @return {?}
         */
            function () {
                // let cursores=['default','crosshair','n-resizea','move','ne-resize','nw-resize','pointer ','se-resize','sw-resize','textm','w-resize','wait'];    
                document.documentElement.style.cursor = 'crosshair';
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.cursorOriginal = /**
         * @return {?}
         */
            function () {
                document.documentElement.style.cursor = "default";
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.botonBuscar = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.busquedasActuales.forEach(( /**
                 * @param {?} busquedas
                 * @return {?}
                 */function (busquedas) {
                    busquedas.cluster.getSource().clear(true);
                }));
                this.buscando = true;
                this.cursorOriginal();
                this.totalEncontrados = 0;
                this.figurasActivas = [];
                // this.arregloCapas.forEach(capa=>{
                //   capa.cluster.getSource().getSource().getFeatures().forEach(Feature=>{
                //    capa.cluster.getSource().getSource().removeFeature(Feature);
                //   })
                // })
                if (this.selectedFeatures['array_'].length > 0) {
                    this.buscarEnFiguraSeleccionada();
                    return true;
                }
                else if (this.infoBusquedas.length == 0) {
                    /** @type {?} */
                    var extent$$1 = this.map.getView().calculateExtent(this.map.getSize());
                    /** @type {?} */
                    var extGeometry = Polygon.fromExtent(extent$$1);
                    /** @type {?} */
                    var coords = extGeometry.getCoordinates();
                    coords = coords[0];
                    /** @type {?} */
                    var coordsLatLon = [];
                    coordsLatLon.push(proj.toLonLat([coords[0][0], coords[0][1]])[0]);
                    coordsLatLon.push(proj.toLonLat([coords[0][0], coords[0][1]])[1]);
                    coordsLatLon.push(proj.toLonLat([coords[1][0], coords[1][1]])[0]);
                    coordsLatLon.push(proj.toLonLat([coords[1][0], coords[1][1]])[1]);
                    coordsLatLon.push(proj.toLonLat([coords[2][0], coords[2][1]])[0]);
                    coordsLatLon.push(proj.toLonLat([coords[2][0], coords[2][1]])[1]);
                    coordsLatLon.push(proj.toLonLat([coords[3][0], coords[3][1]])[0]);
                    coordsLatLon.push(proj.toLonLat([coords[3][0], coords[3][1]])[1]);
                    coordsLatLon.push(proj.toLonLat([coords[0][0], coords[0][1]])[0]);
                    coordsLatLon.push(proj.toLonLat([coords[0][0], coords[0][1]])[1]);
                    console.log(coordsLatLon);
                    this.busquedaGeo(coordsLatLon, 'Polygon', 5, extent$$1);
                    this.consultarV2();
                    return true;
                }
                console.log("INFORMACION A BUSCAR>>>>", this.infoBusquedas);
                // document.getElementById('Cbox1')['checked']=false;
                this.figurasActivas = [];
                this.infoBusquedas.forEach(( /**
                 * @param {?} param
                 * @return {?}
                 */function (param) {
                    console.log(_this.infoBusquedas);
                    console.log("INFOBUSQUEDAS>>>>", param);
                    _this.busquedaGeo(param.coords, param.type, param.distance, param.extent);
                    _this.consultarV2();
                }));
            };
        /**
         * @param {?} status
         * @return {?}
         */
        MapaComponent.prototype.cambiarMapaCalor = /**
         * @param {?} status
         * @return {?}
         */
            function (status) {
                //buscar que capa esta encendida, si esta prendida google maps
                // let strokeProp = new Stroke({ color: 'black', width: 2 });
                // let goldFill = new Fill({ color: 'blue' });
                // let styleCache = {};
                // if(status==true){
                //   this.busquedaFacetLayer.setVisible(false);
                //   this.mapaCalor.setVisible(true);
                //   console.log("entro a status truue");
                //  let style = (feature, resolution) =>
                //   {	
                //     let size = feature.get('features').length;
                //     let style;
                //     if(size>1){
                //       let color = size>25 ? "192,0,0" : size>8 ? "255,128,0" : "0,128,0";
                //         let radius = Math.max(8, Math.min(size*0.75, 20));
                //         let dash1 = 2*Math.PI*radius/6;
                //         let dash2 = [ 0, dash1, dash1, dash1, dash1, dash1, dash1 ];
                //         style = styleCache[size] = new Style(
                //           {	image: new CircleStyle(
                //             {	radius: radius,
                //               stroke: new Stroke(
                //                 {	color: "rgba("+color+",0.5)", 
                //                 width: 15 ,
                //                 lineDash: dash2,
                //                 lineCap: "butt"
                //               }),
                //               fill: new Fill(
                //                 {	color:"rgba("+color+",1)"
                //               })
                //             }),
                //             text: new Text(
                //             {	text: size.toString(),
                //               fill: new Fill(
                //                 {	color: '#fff'
                //               })
                //             })
                //           });
                //           return [style];
                //       }
                //     else{
                //       try{
                //         let feat = feature.get('features');
                //         let src=feat[0].getStyle().getImage().getSrc();
                //         let style=feat[0].getStyle();
                //         if (!styleCache[src]) {
                //           styleCache[src] =style;
                //           }
                //           return styleCache[src];
                //         }
                //         catch{
                //           let style = new Style({
                //             image: new RegularShape({
                //               fill: goldFill,
                //               stroke: strokeProp,
                //               points: 4,
                //               radius: 10,
                //               angle: Math.PI / 4
                //             }),
                //             text: new Text({
                //               text: "1",
                //               fill: new Fill({
                //                 color: '#fff'
                //               })
                //             })
                //           });
                //           return style;
                //         }
                //       }
                //   }
                //   this.busquedasActuales.forEach(busqueda=>{
                //     busqueda.cluster.setStyle(style);
                //   })
                // }
                // else{
                //   let style  =  (feature, resolution)=>
                //     {	let size = feature.get('features').length;
                //     if(size>1){
                //       // console.log("Esta inactivo");
                //       let size;
                //       if (!feature || feature.get('features') === undefined) { size = 0 }
                //       else { size = feature.get('features').length }
                //       let style = styleCache[size];
                //       if (!style) {
                //         style = new Style({
                //           image: new RegularShape({
                //             fill: goldFill,
                //             stroke: strokeProp,
                //             points: 4,
                //             radius: 10,
                //             angle: Math.PI / 4
                //           }),
                //           text: new Text({
                //             text: size.toString(),
                //             fill: new Fill({
                //               color: '#fff'
                //             })
                //           })
                //         });
                //         styleCache[size] = style;
                //       }
                //       return style;
                //     }
                //     else{
                //       try{
                //         let feat = feature.get('features');
                //         let src=feat[0].getStyle().getImage().getSrc();
                //         let style=feat[0].getStyle();
                //         if (!styleCache[src]) {
                //           styleCache[src] =style;
                //           }
                //           return styleCache[src];
                //         }
                //         catch{
                //           let style = new Style({
                //             image: new RegularShape({
                //               fill: goldFill,
                //               stroke: strokeProp,
                //               points: 4,
                //               radius: 10,
                //               angle: Math.PI / 4
                //             }),
                //             text: new Text({
                //               text: "1",
                //               fill: new Fill({
                //                 color: '#fff'
                //               })
                //             })
                //           });
                //           return style;
                //         }
                //       }
                //   }
                //   this.busquedasActuales.forEach(busqueda=>{
                //     busqueda.cluster.setStyle(style);
                //   })
                // }
            };
        /**
         * @param {?} p1
         * @param {?} p2
         * @return {?}
         */
        MapaComponent.prototype.calcularPuntoMedio = /**
         * @param {?} p1
         * @param {?} p2
         * @return {?}
         */
            function (p1, p2) {
                /** @type {?} */
                var x1 = p1[0];
                /** @type {?} */
                var y1 = p1[1];
                /** @type {?} */
                var x2 = p2[0];
                /** @type {?} */
                var y2 = p2[1];
                /** @type {?} */
                var x3;
                /** @type {?} */
                var y3;
                x3 = (x1 + x2) / 2;
                y3 = (y1 + y2) / 2;
                return [x3, y3];
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.buscarEnFiguraSeleccionada = /**
         * @return {?}
         */
            function () {
                this.ocultarClickDerechoMenu();
                if (this.selectedFeatures['array_'][0]) {
                    /** @type {?} */
                    var ObjGeo = this.selectedFeatures['array_'][0].getGeometry();
                    // let Coords:Array<number> =
                    /** @type {?} */
                    var CoordsLonlat_1 = [];
                    /** @type {?} */
                    var coordss = ObjGeo.getCoordinates();
                    coordss[0].forEach(( /**
                     * @param {?} coords
                     * @return {?}
                     */function (coords) {
                        /** @type {?} */
                        var lonLat = proj.toLonLat(coords);
                        CoordsLonlat_1.push(lonLat[0]);
                        CoordsLonlat_1.push(lonLat[1]);
                    }));
                    console.log("Objeto Geo", ObjGeo);
                    /** @type {?} */
                    var extent$$1 = extent.createEmpty();
                    if (ObjGeo) {
                        extent.extend(extent$$1, ObjGeo.getExtent());
                        this.map.getView().fit(extent$$1);
                    }
                    this.busquedaGeo(CoordsLonlat_1, "Polygon", 5, ObjGeo.getExtent());
                    this.consultarV2();
                }
            };
        /**
         * @param {?} boolOnOff
         * @param {?} input
         * @param {?} map
         * @param {?=} This
         * @return {?}
         */
        MapaComponent.prototype.InitBusquedaGM = /**
         * @param {?} boolOnOff
         * @param {?} input
         * @param {?} map
         * @param {?=} This
         * @return {?}
         */
            function (boolOnOff, input, map, This) {
                if (This === void 0) {
                    This = this;
                }
                /** @type {?} */
                var mapElement = document.getElementById("map");
                if (boolOnOff) {
                    /** @type {?} */
                    var _view_1 = this.map.getView();
                    console.log(input);
                    // console.log(google.maps.places.SearchBox);
                    // let places = google.maps.places.Autocomplete;
                    /** @type {?} */
                    var searchBox = new google.maps.places.SearchBox(input);
                    //_gMap.controls[google.maps.ControlPosition.RIGHT_CENTER].push(input);
                    // let map = document.getElementById("map");
                    // Bias the SearchBox results towards current map's viewport.
                    mapElement.addEventListener('bounds_changed', ( /**
                     * @return {?}
                     */function () {
                        searchBox.setBounds(map.getBounds());
                    }));
                    /** @type {?} */
                    var markers = [];
                    // Listen for the event fired when the user selects a prediction and retrieve
                    // more details for that place.
                    searchBox.addListener('places_changed', ( /**
                     * @return {?}
                     */function () {
                        /** @type {?} */
                        var places = searchBox.getPlaces();
                        if (places.length == 0) {
                            return;
                        }
                        if (This.featureAnteriorDireccion != undefined) {
                            if (This.source.hasFeature(This.featureAnteriorDireccion)) {
                                This.source.removeFeature(This.featureAnteriorDireccion);
                            }
                        }
                        // Clear out the old markers.
                        markers.forEach(( /**
                         * @param {?} marker
                         * @return {?}
                         */function (marker) {
                            marker.setMap(null);
                        }));
                        markers = [];
                        // For each place, get the icon, name and location.
                        /** @type {?} */
                        var bounds = new google.maps.LatLngBounds();
                        places.forEach(( /**
                         * @param {?} place
                         * @return {?}
                         */function (place) {
                            if (!place.geometry) {
                                console.log("Returned place contains no geometry");
                                return;
                            }
                            /** @type {?} */
                            var icon = {
                                url: place.icon,
                                size: new google.maps.Size(71, 71),
                                origin: new google.maps.Point(0, 0),
                                anchor: new google.maps.Point(17, 34),
                                scaledSize: new google.maps.Size(25, 25)
                            };
                            // console.log("Tiipos", place.types)
                            map.getView().setCenter(proj.fromLonLat([place.geometry.location.lng(), place.geometry.location.lat()]));
                            map.getView().setZoom(13);
                            // map.getView().setZoom();
                            // Create a marker for each place.
                            markers.push(new google.maps.Marker({
                                map: map,
                                icon: icon,
                                title: place.name,
                                position: place.geometry.location
                            }));
                            /** @type {?} */
                            var style$$1 = new style.Style({
                                image: new style.Icon({
                                    anchor: [0.5, 0.5],
                                    anchorXUnits: IconAnchorUnits.FRACTION,
                                    anchorYUnits: IconAnchorUnits.FRACTION,
                                    crossOrigin: 'anonymous',
                                    src: "https://cdn3.iconfinder.com/data/icons/shopping-and-market/512/pin_marker_location_mark_navigation_flat_icon-512.png",
                                    scale: 0.1
                                })
                            });
                            /** @type {?} */
                            var feature = new ol.Feature({
                                geometry: new geom.Point(proj.fromLonLat([place.geometry.location.lng(), place.geometry.location.lat()]))
                            });
                            feature.setStyle(style$$1);
                            This.featureAnteriorDireccion = feature;
                            This.source.addFeature(feature);
                            console.log("Marcadores", markers);
                            if (place.geometry.viewport) {
                                // Only geocodes have viewport.
                                bounds.union(place.geometry.viewport);
                            }
                            else {
                                bounds.extend(place.geometry.location);
                            }
                        }));
                        //_gMap.fitBounds(bounds);
                        console.log(bounds);
                        /** @type {?} */
                        var extent$$1 = [bounds['ga']['j'], bounds['na']['j'], bounds['ga']['l'], bounds['na']['l']];
                        console.log([bounds['ga']['j'], bounds['na']['j'], bounds['ga']['l'], bounds['na']['l']]);
                        // var centerBBOX = getCenter(extent);
                        // _view.setCenter(transform(centerBBOX, 'EPSG:4326', 'EPSG:3857'));
                        // if (places.length <= 1) {
                        //     _view.setZoom(16);
                        // } else {
                        /** @type {?} */
                        var extentResolution = _view_1.getResolutionForExtent(proj.transformExtent(extent$$1, 'EPSG:4326', 'EPSG:3857'));
                        /** @type {?} */
                        var zoom = _view_1.getZoomForResolution(extentResolution);
                        console.log(zoom);
                        _view_1.setZoom(Math.floor(zoom));
                        // }
                    }));
                }
                else {
                    google.maps.event.clearListeners(mapElement, "bounds_changed");
                    google.maps.event.clearListeners(mapElement, "places_changed");
                    google.maps.event.clearInstanceListeners(input);
                }
            };
        /**
         * @param {?} header
         * @param {?} feature
         * @param {?=} This
         * @return {?}
         */
        MapaComponent.prototype.llenarPopUp = /**
         * @param {?} header
         * @param {?} feature
         * @param {?=} This
         * @return {?}
         */
            function (header, feature, This) {
                var _this = this;
                if (This === void 0) {
                    This = this;
                }
                console.log(header);
                /** @type {?} */
                var contents;
                this.content.innerHTML += "<div class=\"card bg-light mb-3\">";
                this.content.innerHTML += "<div class=\"card-header\">" + header + "</div>";
                this.content.innerHTML += "<div class=\"card-body\">";
                /** @type {?} */
                var arrayValues;
                /** @type {?} */
                var arrayKeys;
                try {
                    contents = feature.values_.content;
                    contents.forEach(( /**
                     * @param {?} contenido
                     * @return {?}
                     */function (contenido) {
                        _this.content.innerHTML += "<p class=\"card-text\">" + contenido.titulo + ": " + contenido.valor + "</p>";
                    }));
                }
                catch (_a) {
                    console.log("Cuidado", " el contenido no es un arreglo de contenido");
                    try {
                        console.log("Intentando convertir un objeto de objetos a arreglo de contenido");
                        arrayValues = Object.values(feature.values_.content);
                        arrayKeys = Object.keys(feature.values_.content);
                        /** @type {?} */
                        var newContent = [];
                        for (var index = 0; index < arrayValues.length; index++) {
                            newContent.push({ titulo: arrayKeys[index], valor: arrayValues[index] });
                        }
                        feature.values_.content = newContent;
                        contents = newContent;
                        contents.forEach(( /**
                         * @param {?} contenido
                         * @return {?}
                         */function (contenido) {
                            _this.content.innerHTML += "<p class=\"card-text\">" + contenido.titulo + ": " + contenido.valor + "</p>";
                        }));
                    }
                    catch (_b) {
                        console.log("ArrayKeys", arrayKeys);
                        console.log("ArrayValues", arrayValues);
                        console.log("contenido", contents);
                        console.log("Falló, corregir el contenido");
                    }
                }
                console.log("ArrayKeys", arrayKeys);
                console.log("ArrayValues", arrayValues);
                console.log("contenido", contents);
                this.content.innerHTML += "<div class=\"card bg-light mb-3\">";
                this.content.innerHTML += "</div></div>";
                // featuresData.push(feature['values_'].data);
            };
        /*
        Metodo para relizar  una busqueda por texto a traves del input.
        */
        /*
          Metodo para relizar  una busqueda por texto a traves del input.
          */
        /**
         * @param {?} fuente
         * @return {?}
         */
        MapaComponent.prototype.seleccionarBusqueda = /*
          Metodo para relizar  una busqueda por texto a traves del input.
          */
            /**
             * @param {?} fuente
             * @return {?}
             */
            function (fuente) {
                var _this = this;
                console.log("Busquedas texto", this.busquedasTexto);
                if (fuente == "Google maps") {
                    this.InitBusquedaGM(true, this.direccionesElement.nativeElement, this.map);
                    this.busquedaTextoActual = null;
                    this.showOption = false;
                    this.inputPlaceholder = "Direcciones";
                    return;
                }
                else {
                    this.InitBusquedaGM(false, this.direccionesElement.nativeElement, this.map);
                }
                this.busquedasActuales2.forEach(( /**
                 * @param {?} item
                 * @return {?}
                 */function (item) {
                    if (fuente != item.titulo) {
                        if (item.visible == true) {
                            _this.cambiarStatusBusqueda(item.titulo);
                        }
                    }
                    else {
                        if (item.visible == false) {
                            _this.cambiarStatusBusqueda(item.titulo);
                        }
                    }
                }));
                this.busquedasTexto.find(( /**
                 * @param {?} busquedaTexto
                 * @return {?}
                 */function (busquedaTexto) {
                    if (busquedaTexto.nombre == fuente) {
                        _this.inputPlaceholder = busquedaTexto.placeholder;
                        _this.busquedaTextoActual = busquedaTexto;
                        // this.busquedaPorOrigen(busquedaTexto.nombre);
                        //Hacer busqueda textual
                        return true;
                    }
                }));
                this.showOption = false;
                if (this.direccionesElement.nativeElement.value != "") {
                    this.busquedaPorTexto();
                }
                else {
                    this.labelActualizar.nativeElement.style.display = "block";
                    this.buscando = true;
                    if (this.source.getFeatures().length == 0) {
                        /** @type {?} */
                        var timerInterval_1;
                        swal.fire({
                            title: 'Buscando...',
                            html: "Iniciando busqueda por \"" + fuente + "\"",
                            timer: 15000,
                            timerProgressBar: true,
                            onBeforeOpen: ( /**
                             * @return {?}
                             */function () {
                                swal.showLoading();
                            }),
                            onClose: ( /**
                             * @return {?}
                             */function () {
                                clearInterval(timerInterval_1);
                            })
                        }).then(( /**
                         * @param {?} result
                         * @return {?}
                         */function (result) {
                            if (
                            /* Read more about swal dismissals below */
                            result.dismiss === swal.DismissReason.timer) {
                                console.log('I was closed by the timer'); // eslint-disable-line
                            }
                        }));
                        this.figurasActivas = [];
                        this.generarFiguraVentana();
                        this.vaciarCajaResultados();
                        this.consultarV2().then(( /**
                         * @param {?} resolve
                         * @return {?}
                         */function (resolve) {
                            swal.close();
                        }));
                    }
                    else {
                        this.figurasActivas = [];
                        this.infoBusquedas.forEach(( /**
                         * @param {?} param
                         * @return {?}
                         */function (param) {
                            console.log(_this.infoBusquedas);
                            console.log("INFOBUSQUEDAS>>>>", param);
                            _this.busquedaGeo(param.coords, param.type, param.distance, param.extent);
                            _this.consultarV2();
                        }));
                    }
                }
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.busquedaPorTexto = /**
         * @return {?}
         */
            function () {
                var _this = this;
                // collapse()
                /*
                  Si busquedaTextoActual es nulo, quiere decir que esta buscando por googlemaps
                */
                if (this.direccionesElement.nativeElement.value == "") {
                    console.log("Error", "Input de busquedas vacio");
                    return;
                }
                if (this.showOption)
                    this.showOption = false;
                if (this.busquedaTextoActual) {
                    /** @type {?} */
                    var nombre_1;
                    /** @type {?} */
                    var url = void 0;
                    /** @type {?} */
                    var texto = void 0;
                    /** @type {?} */
                    var campo = void 0;
                    if (this.filtroConcat) {
                        if (this.filtroConcat.length > 1)
                            nombre_1 = this.busquedaTextoActual.nombre + ";" + this.filtroConcat.slice(0, this.filtroConcat.length - 1);
                        else
                            nombre_1 = this.busquedaTextoActual.nombre;
                    }
                    else
                        nombre_1 = this.busquedaTextoActual.nombre;
                    url = this.confBusquedaText.URL;
                    campo = this.busquedaTextoActual.campo; //filtros
                    texto = this.direccionesElement.nativeElement.value;
                    /** @type {?} */
                    var params = {
                        texto: texto,
                        tipo: nombre_1,
                        //Origen
                        campo: campo
                    };
                    console.log("URL>>>>>><<", url);
                    console.log("params>>>>>><<", params);
                    this.http.post(url, params).subscribe(( /**
                     * @param {?} data
                     * @return {?}
                     */function (data) {
                        if (data.length == 0 || data == null || data == undefined) {
                            swal.fire('Ooops', 'No se encontraron resultados en esta area', 'info');
                        }
                        else {
                            _this.resultadoPorBusquedaTextoAsync(nombre_1, data);
                        }
                    }));
                }
            };
        /**
         * @param {?} nombre
         * @param {?} dataResponse
         * @return {?}
         */
        MapaComponent.prototype.resultadoPorBusquedaTextoAsync = /**
         * @param {?} nombre
         * @param {?} dataResponse
         * @return {?}
         */
            function (nombre, dataResponse) {
                this.busquedaClusterLayer.getSource().getSource().clear();
                this.busquedaFacetLayer.getSource().clear();
                /** @type {?} */
                var found;
                /** @type {?} */
                var layer$$1;
                console.log("Busquedas actuales", this.busquedasActuales);
                console.log("Capas actuales", this.capasActuales);
                //Buscar en los objetos capa primero.
                this.capasActuales.find(( /**
                 * @param {?} capa
                 * @return {?}
                 */function (capa) {
                    if (capa.nombre == nombre) {
                        layer$$1 = capa.layer;
                        found = true;
                        return true;
                    }
                }));
                if (!found) {
                    this.busquedaTextoLayer.getSource().getSource().clear();
                    layer$$1 = this.busquedaTextoLayer;
                }
                console.log("Respuesta Busqueda texto: ", dataResponse);
                // Modelo Respuesta Universal
                // let parserWKT =  new io.WKTReader();
                // let parserOL3 =  new io.OL3Parser();
                // parserOL3.inject(Point, LineString, LinearRing, Polygon, MultiPoint, MultiLineString, MultiPolygon);
                /*
                {
                  objWKT = Point(x y)
                  Icon = http://localhost/icon.jpg
                }*/
                dataResponse.forEach(( /**
                 * @param {?} respuesta
                 * @return {?}
                 */function (respuesta) {
                    if (layer$$1.getVisible() == false) {
                        layer$$1.setVisible(true);
                    }
                    // let geoWKT:string =respuesta.geometry;
                    // let geoOL3 = parserOL3.write(parserWKT.read(geoWKT.toUpperCase()));
                    /** @type {?} */
                    var format = new WKT();
                    /** @type {?} */
                    var feature = format.readFeature(respuesta.geometry, { featureProjection: 'EPSG:3857', dataProjection: 'EPSG:4326' });
                    // feature.setProperties({icon:respuesta.icon});
                    if (respuesta.icon != undefined && respuesta.icon != "") {
                        /** @type {?} */
                        var iconStyle = new style.Style({
                            image: new style.Icon({
                                anchor: [0.5, 20],
                                anchorXUnits: IconAnchorUnits.FRACTION,
                                anchorYUnits: IconAnchorUnits.PIXELS,
                                crossOrigin: 'anonymous',
                                src: respuesta.icon,
                                scale: 0.8
                            })
                        });
                        feature.setStyle(iconStyle);
                    }
                    // feature.setProperties({urlDetalle:this.confBusquedaGeo.URLDetalle});
                    feature.setProperties({ UUID: respuesta.UUID });
                    feature.setProperties({ total: respuesta.total });
                    // console.log("Geometria resultante de la busqueda por texto",feature.getGeometry());
                    //Convertir lat lon a x y
                    // console.log("Feature resultante de la busqueda por texto",feature);
                    layer$$1.getSource().getSource().addFeature(feature);
                }));
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.openNav = /**
         * @return {?}
         */
            function () {
                document.getElementsByClassName("ol-zoom").item(0).setAttribute("style", "margin-left:30%;transition: 0.5s;");
                console.log("filtrosGlobales>>>", this.filtrosGlobales);
                document.getElementById("mySidepanel").style.width = "30%";
                document.getElementById("openbtn").style.display = "none";
                document.getElementById("openBtnMas").style.display = "block";
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.openNavMas = /**
         * @return {?}
         */
            function () {
                document.getElementById("openBtnMas").style.display = "none";
                document.getElementById("mySidepanel").style.width = "100%";
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.closeNav = /**
         * @return {?}
         */
            function () {
                document.getElementsByClassName("ol-zoom").item(0).setAttribute("style", "margin-left:0px;transition: 0.5s;");
                document.getElementById("openBtnMas").style.display = "none";
                this.isCollapsedR = true;
                document.getElementById("mySidepanel").style.width = "0";
                document.getElementById("openbtn").style.display = "block";
                this.buscarArea.nativeElement.style.display = "none";
                this.vaciarCajaResultados();
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.ocultarClickDerechoMenu = /**
         * @return {?}
         */
            function () {
                this.menuElement.nativeElement.style.display = "none";
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.clickDerechoMenu = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var toggleMenu = ( /**
                 * @param {?} command
                 * @return {?}
                 */function (command) {
                    _this.menuElement.nativeElement.style.display = command === "show" ? "block" : "none";
                });
                /** @type {?} */
                var setPosition = ( /**
                 * @param {?} __0
                 * @return {?}
                 */function (_a) {
                    var top = _a.top, left = _a.left;
                    _this.menuElement.nativeElement.style.left = left + "px";
                    _this.menuElement.nativeElement.style.top = top + "px";
                    toggleMenu('show');
                });
                window.addEventListener("contextmenu", ( /**
                 * @param {?} e
                 * @return {?}
                 */function (e) {
                    e.preventDefault();
                    /** @type {?} */
                    var origin = {
                        left: e.pageX,
                        top: e.pageY
                    };
                    setPosition(origin);
                    return false;
                }));
            };
        /**
         * @param {?} This
         * @return {?}
         */
        MapaComponent.prototype.InicializarEventoViewChange = /**
         * @param {?} This
         * @return {?}
         */
            function (This) {
                this.view.on('change', ( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) {
                    console.log('evento =>', event);
                    This.viewChanged.next(event);
                }));
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.consultarV2 = /**
         * @return {?}
         */
            function () {
                var _this = this;
                return new Promise(( /**
                 * @param {?} resolve
                 * @return {?}
                 */function (resolve) {
                    /** @type {?} */
                    var capa;
                    /** @type {?} */
                    var TipoResultado = "";
                    _this.infoDetTitulo = [];
                    _this.infoDetalle = [];
                    //Get values
                    _this.infoDetValues = [];
                    _this.infoTitulos = [];
                    _this.infoDetBotones = [];
                    console.log(_this.view.getZoom());
                    // Buscar que capa prender,tipo de resultado que se necesite y layer en el cual se le insertará datos 
                    if (_this.view.getZoom() < 15) {
                        _this.busquedaClusterLayer.setVisible(false);
                        if (_this.statusMapaCalor) {
                            _this.mapaCalor.setVisible(true);
                            _this.busquedaFacetLayer.setVisible(false);
                            TipoResultado = "HeatMap";
                            // this.mapaCalor.setRadius(70-this.view.getZoom());
                        }
                        else {
                            TipoResultado = "Facet";
                            _this.busquedaFacetLayer.setVisible(true);
                            _this.mapaCalor.setVisible(false);
                        }
                        capa = _this.busquedaFacetLayer;
                    }
                    else {
                        _this.spinner.show();
                        _this.busquedaClusterLayer.setVisible(true);
                        _this.busquedaFacetLayer.setVisible(false);
                        _this.mapaCalor.setVisible(false);
                        //   // if(this.busquedaAnterior!=this.figurasActivas){
                        TipoResultado = "Resultado";
                        capa = _this.busquedaClusterLayer;
                        //     this.pedirdatosResult=true;
                        //     this.busquedaAnterior=this.figurasActivas;
                    }
                    //   // else{
                    //     // console.log("Ya  se  obtuvieron esos datos.");
                    //     // return ;
                    //   // }
                    // }
                    // Concatenar los tipos de origenes.
                    /** @type {?} */
                    var tiposOrigen = "";
                    _this.tiposOrigenes.forEach(( /**
                     * @param {?} tipo
                     * @return {?}
                     */function (tipo) {
                        if (tipo != null) {
                            tiposOrigen += "tipoOrigen=" + tipo + ";";
                        }
                    }));
                    tiposOrigen = tiposOrigen.slice(0, tiposOrigen.length - 1);
                    /** @type {?} */
                    var ext = _this.map.getView().calculateExtent(_this.map.getSize());
                    /** @type {?} */
                    var minXYLonLat = proj.toLonLat([ext[0], ext[1]]);
                    /** @type {?} */
                    var maxXYLonLat = proj.toLonLat([ext[2], ext[3]]);
                    /** @type {?} */
                    var extWKTVentana = "[" + minXYLonLat[0] + " " + minXYLonLat[1] + " TO " + maxXYLonLat[0] + " " + maxXYLonLat[1] + "]";
                    if (_this.figurasActivas.length == 0) {
                        console.log('No se encontro alguna figura para buscar');
                        _this.spinner.hide();
                        return;
                    }
                    else
                        _this.busquedaTextoLayer.getSource().getSource().clear();
                    /** @type {?} */
                    var filtrosGenerales = "";
                    if (_this.filtroConcat) {
                        filtrosGenerales += _this.filtroConcat;
                    }
                    _this.filtrosGlobales.forEach(( /**
                     * @param {?} filtro
                     * @return {?}
                     */function (filtro) {
                        /** @type {?} */
                        var valueDate = "";
                        if (filtro.type == "range_date") {
                            if (filtro.valueFormat.startDate == null || filtro.valueFormat.endDate == null) {
                                return true;
                            }
                            else {
                                /** @type {?} */
                                var date1 = void 0;
                                /** @type {?} */
                                var date2 = void 0;
                                date1 = filtro.valueFormat.startDate.toDate();
                                /** @type {?} */
                                var day1 = date1.getDay().length == 1 ? date1.getDay() : "0" + date1.getDay();
                                /** @type {?} */
                                var month1 = date1.getMonth().length == 1 ? date1.getMonth() : "0" + date1.getMonth();
                                date2 = filtro.valueFormat.endDate.toDate();
                                /** @type {?} */
                                var day2 = date2.getDay().length == 1 ? date2.getDay() : "0" + date2.getDay();
                                /** @type {?} */
                                var month2 = date2.getMonth().length == 1 ? "0" + date2.getMonth() : date2.getMonth();
                                valueDate = "[" + date1.getFullYear() + "-" + month1 + "-" + day1 + "T00:00:00Z TO " + date2.getFullYear() + "-" + month2 + "-" + day2 + "T23:59:59Z]";
                                filtrosGenerales += filtro.name + "=" + valueDate + ";";
                            }
                        }
                        else {
                            filtrosGenerales += filtro.name + "=" + filtro.valueFormat + ";";
                        }
                    }));
                    filtrosGenerales = filtrosGenerales.slice(0, filtrosGenerales.length - 1);
                    console.log('Filtros generales', filtrosGenerales);
                    /** @type {?} */
                    var tipo = TipoResultado;
                    if (tipo == "Resultado")
                        tipo = 'Facet';
                    /** @type {?} */
                    var param = {
                        ExtWKT: extWKTVentana,
                        GeometryWKT: _this.figurasActivas,
                        TipoResultado: tipo,
                        TipoOrigen: tiposOrigen,
                        Filtros: filtrosGenerales,
                        Zoom: _this.map.getView().getZoom()
                    };
                    console.log("Parametros", param);
                    // let URL = _url;
                    /** @type {?} */
                    var URL = _this.confBusquedaGeo.URLbusqueda;
                    _this.http.post(URL, param, { headers: new http.HttpHeaders({ 'Content-Type': 'application/json' }) }).subscribe(( /**
                     * @param {?} data
                     * @return {?}
                     */function (data) {
                        if (data.length == 0 || data == null || data == undefined) {
                            resolve(false);
                            swal.fire('Ooops', 'No se encontraron resultados en esta area', 'info');
                            _this.spinner.hide();
                            // swal('Info', 'No se encontraron resultados', 'info');
                            // this.figurasActivas=[];
                        }
                        else {
                            switch (TipoResultado) {
                                case "Facet":
                                    capa.getSource().clear(true);
                                    break;
                                case "HeatMap":
                                    _this.mapaCalor.getSource().clear(true);
                                    console.log("Se limpio el mapa de calor");
                                    break;
                                default:
                                    capa.getSource().getSource().clear(true);
                                    break;
                            }
                            resolve(true);
                            //contar tiempo de aca
                            _this.agregarFeatureExperimental(data, capa, TipoResultado);
                            // a aca
                            //si es mas de 2 segundos mostrar spinner
                            _this.spinner.hide();
                            console.log("ResponseData=>", data);
                        }
                    }));
                }));
            };
        /**
         * @param {?} data
         * @param {?} layer
         * @param {?} tipo
         * @return {?}
         */
        MapaComponent.prototype.agregarFeatureExperimental = /**
         * @param {?} data
         * @param {?} layer
         * @param {?} tipo
         * @return {?}
         */
            function (data, layer$$1, tipo) {
                var _this = this;
                // data.forEach(feature => {
                //   let fture= new Feature({
                //     geometry:new Point(fromLonLat(feature.Coordenadas)),
                //     texto:feature.Detalle.texto
                //   })fd
                console.log("Datos busqueda geo", data);
                // let geoJsonFormat = new GeoJson();
                // let features = geoJsonFormat.readFeatures(data, {featureProjection: 'EPSG:3857',dataProjection:'EPSG:4326'});
                data.forEach(( /**
                 * @param {?} respuesta
                 * @return {?}
                 */function (respuesta) {
                    console.log(respuesta);
                    // if(layer.getVisible()==false){
                    //   layer.setVisible(true);
                    // }
                    // let geoWKT:string =respuesta.geometry;
                    // let geoOL3 = parserOL3.write(parserWKT.read(geoWKT.toUpperCase()));
                    /** @type {?} */
                    var format = new WKT();
                    /** @type {?} */
                    var feature;
                    if (tipo == 'HeatMap') {
                        feature = format.readFeature(respuesta.polygon, { featureProjection: 'EPSG:3857', dataProjection: 'EPSG:4326' });
                        /** @type {?} */
                        var total = respuesta.total;
                        /** @type {?} */
                        var color = "0,128,0";
                        /** @type {?} */
                        var weight = respuesta.total > 25 ? 1 : respuesta.total > 8 ? 0.7 : 0.4;
                        if (total == null || total == undefined)
                            color = "0,128,0";
                        // let color =>25 ? "192,0,0" : feature.get('total')>8 ? "255,128,0" : "0,128,0";
                        /** @type {?} */
                        var polygonStyle = new style.Style({
                            stroke: new style.Stroke({
                                color: "rgba(" + color + ", 0.5)",
                                width: 3
                            }),
                            fill: new style.Fill({
                                color: "rgba(" + color + ", " + weight + ")"
                            })
                        });
                        feature.setStyle(polygonStyle);
                        console.log(total, color);
                    }
                    else
                        feature = format.readFeature(respuesta.geometry, { featureProjection: 'EPSG:3857', dataProjection: 'EPSG:4326' });
                    if (respuesta.total == "1" && respuesta.icon != null) {
                        //Si no es heatmap se pone el estilo
                        if (tipo != "HeatMap") {
                            /** @type {?} */
                            var iconStyle = new style.Style({
                                image: new style.Icon({
                                    anchor: [0.5, 20],
                                    anchorXUnits: IconAnchorUnits.FRACTION,
                                    anchorYUnits: IconAnchorUnits.PIXELS,
                                    crossOrigin: 'anonymous',
                                    src: respuesta.icon,
                                    scale: 0.8
                                })
                            });
                            feature.setStyle(iconStyle);
                        }
                    }
                    // feature.setProperties({urlDetalle:this.confBusquedaGeo.URLDetalle});
                    feature.setProperties({ UUID: respuesta.UUID });
                    feature.setProperties({ polygon: respuesta.polygon });
                    feature.setProperties({ total: respuesta.total });
                    feature.setProperties({ weight: respuesta.total });
                    // console.log("Geometria resultante de la busqueda por texto",feature.getGeometry());
                    //Convertir lat lon a x y
                    // console.log("Feature resultante de la busqueda por texto",feature);
                    if (tipo == 'Resultado') {
                        // feature.setId(respuesta.UUID);
                        layer$$1.getSource().getSource().addFeature(feature);
                    }
                    else if (tipo == 'Facet') {
                        layer$$1.getSource().addFeature(feature);
                        // layer.getSource().getSource().addFeature(feature);
                    }
                    else if (tipo == "HeatMap") {
                        _this.mapaCalor.getSource().addFeature(feature);
                        console.log(feature);
                    }
                }));
                // console.log(layer.getSource());
                // let source = layer.getSource();
                // source.addFeature(fture);
                // });
            };
        /**
         * @param {?} titulo
         * @return {?}
         */
        MapaComponent.prototype.cambiarStatusBusqueda = /**
         * @param {?} titulo
         * @return {?}
         */
            function (titulo) {
                var _this = this;
                console.log("AASD");
                this.busquedasActuales2.find(( /**
                 * @param {?} item
                 * @return {?}
                 */function (item) {
                    if (titulo == item.titulo) {
                        if (item.visible == true) {
                            _this.tiposOrigenes[_this.tiposOrigenes.indexOf(item.nombre)] = null;
                            item.visible = false;
                            _this.confBusquedaGeo.filtros.forEach(( /**
                             * @param {?} filtro
                             * @return {?}
                             */function (filtro) {
                                if (filtro.origen == item.nombre) {
                                    /** @type {?} */
                                    var obj = new ngbiFilters.Filter();
                                    obj.name = filtro.nombre;
                                    obj.title = filtro.titulo;
                                    obj.type = filtro.tipo; //date, text, select
                                    obj.valueFormat = filtro.valordefault; //date, text, select
                                    _this.filtrosGlobales.splice(_this.filtrosGlobales.indexOf(obj), 1);
                                }
                            }));
                        }
                        else {
                            _this.confBusquedaGeo.filtros.forEach(( /**
                             * @param {?} filtro
                             * @return {?}
                             */function (filtro) {
                                if (filtro.origen == item.nombre) {
                                    /** @type {?} */
                                    var obj = new ngbiFilters.Filter();
                                    obj.name = filtro.nombre;
                                    obj.title = filtro.titulo;
                                    obj.type = filtro.tipo; //date, text, select
                                    obj.valueFormat = filtro.valordefault; //date, text, select
                                    _this.filtrosGlobales.push(obj);
                                }
                            }));
                            item.visible = true;
                            _this.tiposOrigenes.push(item.nombre);
                        }
                        return true;
                    }
                }));
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.buscarDetalle = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var param = {
                    GeometrysWKT: this.paginacionGeo.geometrysWKT,
                    TipoOrigen: this.paginacionGeo.tipoOrigen,
                    PagActual: this.paginacionGeo.pagActual,
                    RPP: this.paginacionGeo.RPP,
                    UUID: this.paginacionGeo.UUID
                };
                console.log("Parametros de busqueda click", param);
                /** @type {?} */
                var URL = this.confBusquedaGeo.URLDetalle;
                this.http.post(URL, param, { headers: new http.HttpHeaders({ 'Content-Type': 'application/json' }) }).subscribe(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) {
                    _this.infoDetalle = data;
                    _this.infoDetTitulo = [];
                    _this.infoDetValues = [];
                    _this.infoTitulos = [];
                    _this.infoDetBotones = [];
                    //Limpiar nulos
                    // this.confResultadosVista.Estructura  
                    _this.infoDetalle.forEach(( /**
                     * @param {?} element
                     * @return {?}
                     */function (element) {
                    }));
                    /** @type {?} */
                    var objVistaTmp;
                    /** @type {?} */
                    var objetoTmp = {};
                    _this.infoDetalle.forEach(( /**
                     * @param {?} element
                     * @return {?}
                     */function (element) {
                        switch (element.TipoOrigen) {
                            case "Bts":
                                objetoTmp = element;
                                //Revisar JSON
                                if (_this.confResultadosVista.Bts.CampoEspeciales != undefined) {
                                    if (_this.confResultadosVista.Bts.CampoEspeciales.JSON != undefined && _this.confResultadosVista.Bts.CampoEspeciales.JSON.length > 0) {
                                        _this.confResultadosVista.Bts.CampoEspeciales.JSON.forEach(( /**
                                         * @param {?} element
                                         * @return {?}
                                         */function (element) {
                                            /** @type {?} */
                                            var objJSON = JSON.parse(objetoTmp[element]);
                                            objetoTmp = Object.assign(objetoTmp, objJSON);
                                        }));
                                    }
                                    //Revisar Fecha
                                    if (_this.confResultadosVista.Bts.CampoEspeciales.fecha != undefined && _this.confResultadosVista.Bts.CampoEspeciales.fecha.length > 0) {
                                        _this.confResultadosVista.Bts.CampoEspeciales.fecha.forEach(( /**
                                         * @param {?} element
                                         * @return {?}
                                         */function (element) {
                                            objetoTmp[element] = _this.obtenerFechaFormateada(objetoTmp[element], 1);
                                        }));
                                    }
                                }
                                objVistaTmp = {};
                                _this.confResultadosVista.Bts.Vista.forEach(( /**
                                 * @param {?} element
                                 * @return {?}
                                 */function (element) {
                                    objVistaTmp[element] = objetoTmp[element];
                                }));
                                if (_this.confResultadosVista.Bts.botones != undefined) {
                                    /** @type {?} */
                                    var tmpBotones_1 = [];
                                    _this.confResultadosVista.Bts.botones.forEach(( /**
                                     * @param {?} boton
                                     * @return {?}
                                     */function (boton) {
                                        tmpBotones_1.push({ clase: boton.clase, accion: boton.accion, contenido: boton.contenido, tipo: boton.tipo });
                                        // `<button type="button" class="${boton.clase}" (click)="clickDetExt(${element},${boton.accion})" >${boton.contenido}</button>`
                                        //  
                                    }));
                                    _this.infoDetBotones.push(tmpBotones_1);
                                    console.log("Botones", tmpBotones_1);
                                }
                                break;
                            case "Chat":
                                objetoTmp = element;
                                //Revisar JSON
                                if (_this.confResultadosVista.Chat.CampoEspeciales != undefined) {
                                    if (_this.confResultadosVista.Chat.CampoEspeciales.JSON != undefined && _this.confResultadosVista.Chat.CampoEspeciales.JSON.length > 0) {
                                        _this.confResultadosVista.Chat.CampoEspeciales.JSON.forEach(( /**
                                         * @param {?} element
                                         * @return {?}
                                         */function (element) {
                                            /** @type {?} */
                                            var objJSON = JSON.parse(objetoTmp[element]);
                                            objetoTmp = Object.assign(objetoTmp, objJSON);
                                        }));
                                    }
                                    //Revisar Fecha
                                    if (_this.confResultadosVista.Chat.CampoEspeciales.fecha != undefined && _this.confResultadosVista.Chat.CampoEspeciales.fecha.length > 0) {
                                        _this.confResultadosVista.Chat.CampoEspeciales.fecha.forEach(( /**
                                         * @param {?} element
                                         * @return {?}
                                         */function (element) {
                                            objetoTmp[element] = _this.obtenerFechaFormateada(objetoTmp[element], 1);
                                        }));
                                    }
                                }
                                objVistaTmp = {};
                                _this.confResultadosVista.Chat.Vista.forEach(( /**
                                 * @param {?} element
                                 * @return {?}
                                 */function (element) {
                                    objVistaTmp[element] = objetoTmp[element];
                                }));
                                if (_this.confResultadosVista.Chat.botones != undefined) {
                                    /** @type {?} */
                                    var tmpBotones_2 = [];
                                    _this.confResultadosVista.Chat.botones.forEach(( /**
                                     * @param {?} boton
                                     * @return {?}
                                     */function (boton) {
                                        tmpBotones_2.push({ clase: boton.clase, accion: boton.accion, contenido: boton.contenido, tipo: boton.tipo });
                                        // `<button type="button" class="${boton.clase}" (click)="clickDetExt(${element},${boton.accion})" >${boton.contenido}</button>`
                                        //  
                                    }));
                                    _this.infoDetBotones.push(tmpBotones_2);
                                }
                                break;
                            case "Nacional":
                                objetoTmp = element;
                                //Revisar JSON
                                if (_this.confResultadosVista.Nacional.CampoEspeciales != undefined) {
                                    if (_this.confResultadosVista.Nacional.CampoEspeciales.JSON != undefined && _this.confResultadosVista.Nacional.CampoEspeciales.JSON.length > 0) {
                                        _this.confResultadosVista.Nacional.CampoEspeciales.JSON.forEach(( /**
                                         * @param {?} element
                                         * @return {?}
                                         */function (element) {
                                            /** @type {?} */
                                            var objJSON = JSON.parse(objetoTmp[element]);
                                            objetoTmp = Object.assign(objetoTmp, objJSON);
                                        }));
                                    }
                                    //Revisar Fecha
                                    if (_this.confResultadosVista.Nacional.CampoEspeciales.fecha != undefined && _this.confResultadosVista.Nacional.CampoEspeciales.fecha.length > 0) {
                                        _this.confResultadosVista.Nacional.CampoEspeciales.fecha.forEach(( /**
                                         * @param {?} element
                                         * @return {?}
                                         */function (element) {
                                            objetoTmp[element] = _this.obtenerFechaFormateada(objetoTmp[element], 1);
                                        }));
                                    }
                                }
                                objVistaTmp = {};
                                _this.confResultadosVista.Nacional.Vista.forEach(( /**
                                 * @param {?} element
                                 * @return {?}
                                 */function (element) {
                                    objVistaTmp[element] = objetoTmp[element];
                                }));
                                if (_this.confResultadosVista.Nacional.botones != undefined) {
                                    /** @type {?} */
                                    var tmpBotones_3 = [];
                                    _this.confResultadosVista.Nacional.botones.forEach(( /**
                                     * @param {?} boton
                                     * @return {?}
                                     */function (boton) {
                                        tmpBotones_3.push({ clase: boton.clase, accion: boton.accion, contenido: boton.contenido, tipo: boton.tipo });
                                        // `<button type="button" class="${boton.clase}" (click)="clickDetExt(${element},${boton.accion})" >${boton.contenido}</button>`
                                        //  
                                    }));
                                    _this.infoDetBotones.push(tmpBotones_3);
                                }
                                break;
                            default:
                                break;
                        }
                        // this.confResultadosVista={
                        //   "Chat":{Vista:["Campo1","Campo2","Campo2"],CampoEspeciales:{JSON:['Modelo','Mensaje'],fecha:"FechaCreacion"}},
                        //   "Bts":{Vista:["Campo1","Campo2","Campo2"],CampoEspeciales:{JSON:['Modelo','Mensaje'],fecha:"FechaCreacion"}},
                        //   "Nacional":{Vista["Campo1","Campo2","Campo2"],CampoEspeciales:{JSON:['Modelo','Mensaje'],fecha:"FechaCreacion"}}
                        // }
                        _this.infoVista.push(objVistaTmp);
                        //Get keys
                        /** @type {?} */
                        var tmpVista = Object.keys(objVistaTmp);
                        tmpVista.shift();
                        _this.infoDetTitulo.push(tmpVista);
                        //Get values
                        /** @type {?} */
                        var tmpValues = Object.values(objVistaTmp);
                        tmpValues.shift();
                        _this.infoDetValues.push(tmpValues);
                        try {
                            _this.infoTitulos.push(Object.values(objVistaTmp)[0].toString());
                        }
                        catch (_a) {
                            console.log(objVistaTmp);
                        }
                        console.log(_this.infoTitulos);
                    }));
                    if (data.length > 0) {
                        // if(this.isCollapsedR){
                        if (_this.isCollapsedR == true) {
                            _this.openNav();
                            _this.isCollapsedR = false;
                        }
                        // }
                    }
                    console.log('info detalle', _this.infoDetalle);
                    console.log('info Titulo', _this.infoDetTitulo);
                    console.log('info Values', _this.infoDetValues);
                    console.log("ResponseDataClick=>", data);
                    console.log("Nuevo info detalle sin nulos", _this.infoDetalle);
                }));
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.detallePaginaSiguiente = /**
         * @return {?}
         */
            function () {
                if (this.infoDetalle.length == this.paginacionGeo.RPP) {
                    this.paginacionGeo.pagActual++;
                    this.buscarDetalle();
                    document.getElementById('mySidepanel').scrollTo(0, 0);
                }
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.detallePaginaAnterior = /**
         * @return {?}
         */
            function () {
                if (this.paginacionGeo.pagActual != 1) {
                    this.paginacionGeo.pagActual--;
                    this.buscarDetalle();
                    document.getElementById('mySidepanel').scrollTo(0, 0);
                }
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.buscarEnFiguraResultados = /**
         * @return {?}
         */
            function () {
                this.ocultarClickDerechoMenu();
                /** @type {?} */
                var feature = this.selectedFeatures['array_'][0];
                /** @type {?} */
                var polygonWKT;
                if (feature != undefined) {
                    /** @type {?} */
                    var format = new WKT();
                    polygonWKT = format.writeFeature(feature, { featureProjection: 'EPSG:3857', dataProjection: 'EPSG:4326' });
                }
                console.log('Figura seleccionada WKT', polygonWKT);
                this.paginacionGeo.geometrysWKT = [polygonWKT];
                this.paginacionGeo.pagActual = 1;
                this.paginacionGeo.RPP = 10;
                this.paginacionGeo.UUID = null;
                this.buscarDetalle();
                // let param = {
                //   GeometrysWKT: this.paginacionGeo.geometrysWKT,
                //   PagActual:this.paginacionGeo.pagActual,
                //   RPP:this.paginacionGeo.RPP,
                //   UUID:this.paginacionGeo.UUID
                // }
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.obtenerConfiguracion = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var URL = this.urlConfiguracion;
                /** @type {?} */
                var param = { App: this.app };
                console.log('Variable app >>>>', this.app);
                console.log('Obteniendo Objeto de configuracion...', URL);
                return this.http.post(URL, param, { headers: new http.HttpHeaders({ 'Content-Type': 'application/json' }) });
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.busquedaInicial = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var tipoYfq;
                /** @type {?} */
                var url;
                /** @type {?} */
                var texto;
                tipoYfq = this.filtroInicial; //TipoOrigen+&+campo:Valor
                url = this.confBusquedaText.URL;
                texto = "Coordenadas:[-90,-180 TO 90,180]";
                /** @type {?} */
                var params = {
                    texto: texto,
                    tipo: tipoYfq,
                    campo: 'Query'
                };
                /** @type {?} */
                var tipo = tipoYfq.split('&')[0];
                console.log("Paramestros>>>>>>>>", params);
                console.log("tipo>>>>>>>>", tipo);
                this.http.post(url, params).subscribe(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) {
                    _this.resultadoPorBusquedaTextoAsync(tipo, data);
                }));
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.busquedaPorArea = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (this.source.getFeatures().length == 0) {
                    this.figurasActivas = [];
                    this.generarFiguraVentana();
                    this.consultarV2();
                }
                else {
                    this.infoBusquedas.forEach(( /**
                     * @param {?} param
                     * @return {?}
                     */function (param) {
                        console.log(_this.infoBusquedas);
                        console.log("INFOBUSQUEDAS>>>>", param);
                        // this.busquedaGeo(param.coords,param.type,param.distance,param.extent);
                        _this.consultarV2();
                    }));
                    console.log(this.infoBusquedas);
                }
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.vaciarCajaResultados = /**
         * @return {?}
         */
            function () {
                this.infoDetTitulo = [];
                this.infoDetValues = [];
                this.infoTitulos = [];
                this.infoDetBotones = [];
            };
        /**
         * @param {?} modelo
         * @param {?} accion
         * @return {?}
         */
        MapaComponent.prototype.clickDetExt = /**
         * @param {?} modelo
         * @param {?} accion
         * @return {?}
         */
            function (modelo, accion) {
                console.log("Si se hizo carnal");
                this.clicExterno.emit({ modelo: modelo, accion: accion });
            };
        /**
         * @return {?}
         */
        MapaComponent.prototype.changeShowValue = /**
         * @return {?}
         */
            function () {
                console.log("Cambiandole el valor al mostrador");
                this.showOption = true;
            };
        MapaComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ngbi-map',
                        template: "\n<ngx-spinner bdColor=\"rgba(51,51,51,0.8)\" size=\"medium\" color=\"#fff\" type=\"ball-grid-beat\">\n    <p style=\"font-size: 20px; color: white\">Cargando...</p>\n</ngx-spinner>\n<div>\n   \n  <div class=\"componentMap\">\n      <!-- Menu principal -->\n      <div class=\"btn-group divMenu\">\n        <div class=\"btn-group\" ngbDropdown role=\"group\" aria-label=\"Button group with nested dropdown\">\n            <button class=\"btn botonMenu\" ngbDropdownToggle>Mapas</button>\n            <div class=\"dropdown-menu\" ngbDropdownMenu>\n              <button ngbDropdownItem (click)=\"funcionesMenu('OSM')\">Open Street Map</button>\n              <button ngbDropdownItem (click)=\"funcionesMenu('Google')\">Google Maps</button>\n            </div>\n          </div>\n          <div *ngIf=\"capasActuales.length>0\" class=\"btn-group\" ngbDropdown role=\"group\" aria-label=\"Button group with nested dropdown\">\n            <button class=\"btn botonMenu\" ngbDropdownToggle>Capas</button>\n            <div class=\"dropdown-menu\" ngbDropdownMenu>\n              <div *ngFor=\"let capa of capasActuales\" style=\"text-align: -webkit-center;\"  class=\"switcher\">\n                  <input type=\"checkbox\" [id]=\"capa.nombre\" name=\"checkbox\" [(ngModel)]=\"capa.layer.values_.visible\">\n                  <label [for]=\"capa.nombre\" style=\"display: -webkit-inline-box;margin-left: 1rem\" >{{capa.nombre}}</label>\n                </div>\n            </div>\n          </div>\n          <div class=\"btn-group\" ngbDropdown role=\"group\" aria-label=\"Button group with nested dropdown\">\n            <button class=\"btn botonMenu\" ngbDropdownToggle>Busquedas</button>\n            <div class=\"dropdown-menu\" ngbDropdownMenu>\n              <div *ngFor=\"let busqueda of busquedasActuales2\" style=\"text-align: -webkit-center;\"  class=\"switcher\">\n                  <input type=\"checkbox\"  name=\"switcher_checkbox_1\" [id]=\"'busqueda'+busqueda.titulo\" checked=\"\" (click)=\"cambiarStatusBusqueda(busqueda.titulo)\" [(ngModel)]=\"busqueda.visible\">\n                  <label [for]=\"'busqueda'+busqueda.titulo\" style=\"display: -webkit-inline-box;margin-left: 1rem\" >{{busqueda.titulo}}</label>\n                </div>\n                  <!-- <button *ngFor=\"let capa of arregloCapas\" (click)=\"modCapa(capa.name)\" ></button> -->\n                </div>\n              </div>\n              <div class=\"btn-group\" ngbDropdown role=\"group\" aria-label=\"Button group with nested dropdown\">\n            <button class=\"btn botonMenu\" ngbDropdownToggle>Geometr\u00EDas</button>\n            <div class=\"dropdown-menu\" ngbDropdownMenu>\n              <button ngbDropdownItem (click)=\"funcionesMenu('Polygon')\">Poligono</button>\n              <button ngbDropdownItem (click)=\"funcionesMenu('Circle')\">Circulo</button>\n              <button ngbDropdownItem (click)=\"funcionesMenu('circleOpt3')\">Circulo dividido</button>\n              <button ngbDropdownItem (click)=\"funcionesMenu('circleOpt1')\">Circulo por medidas</button>\n              <button ngbDropdownItem (click)=\"funcionesMenu('circleOpt2')\">Circulo dividido x medidas</button>\n            </div>\n          </div>\n          \n          <div class=\"btn-group\" ngbDropdown role=\"group\" aria-label=\"Button group with nested dropdown\">\n            <button class=\"btn botonMenu\" ngbDropdownToggle>Vista</button>\n            <div class=\"dropdown-menu\" ngbDropdownMenu>\n              <button ngbDropdownItem (click)=\"funcionesMenu('mapCalor')\">Mapa de calor</button>\n              <button ngbDropdownItem (click)=\"funcionesMenu('mapPuntos')\">Mapa de puntos</button>\n            </div>\n          </div>\n          \n          <!-- <div class=\"btn-group\" ngbDropdown role=\"group\" aria-label=\"Button group with nested dropdown\">\n            <button class=\"btn botonMenu\" ngbDropdownToggle>Extras</button>\n            <div class=\"dropdown-menu\" ngbDropdownMenu>\n            </div>\n          </div> -->\n      \n          <button type=\"button\" class=\"btn btn-success btnbuscar\"  (click)=\"botonBuscar()\">Buscar</button>\n          <button type=\"button\" class=\"btn btn-primary btnbuscar\"  (click)=\"eliminarTodo()\">Limpiar</button>\n          <button type=\"button\" #colorPicker class=\"btn btn-white btnbuscar\" cpOutputFormat=\"rgba\" [(colorPicker)]=\"color\"  cpOKButton=\"true\" [style.border-color]=\"color\" [style.background]=\"color\"> Color</button>\n      </div>\n      <div class=\"divBuscarArea\">\n          <button  #buscarArea id=\"buscarArea\" class=\"btn btn-secondary\" (click)=\"busquedaPorArea()\">Buscar en esta Area</button>\n      </div>\n    <!-- Resto -->\n    <div style=\"position: relative;\">\n        <!-- Menu lateral -->\n        <div id=\"mySidepanel\" class=\"panel panel-inverse sidepanel\" data-sortable-id=\"ui-widget-1\">\n            <div class=\"panel-heading\" style=\"border-style: solid;border-color: rgba(159, 177, 226, 0.5);background-color:rgba(79, 131, 183, 0.7) !important; color:white;\">\n                <h4 class=\"panel-title\">Menu <a href=\"javascript:void(0)\" class=\"closebtn\" (click)=\"closeNav()\">\u00D7</a></h4> \n              </div>\n            <div class=\"panel-body custom-panel\" >\n              <!-- subpanel -->\n              <input #inputDirecciones id=\"inputDirecciones\" type=\"text\" class=\"form-control input-white\" (click)=\"changeShowValue()\" (keyup.Enter)=\" busquedaPorTexto()\" [placeholder]=\"inputPlaceholder+'...'\" />  \n              <div id=\"OptionExtrasBusquedas\" *ngIf=\"showOption\">\n                <!-- begin #accordion -->\n                <!-- <div class=\"panel-heading\" style=\"background-color:rgba(79, 131, 183, 0.7) !important; color:white;\">\n                    <h4 class=\"panel-title\">Buscar en</h4> \n                  </div> -->\n                  <div class=\"panel-body caja\" style=\"background-color: white\">\n                      <div class=\"row\">\n                        <div  *ngFor=\"let busqueda of busquedasTexto\"class=\"cardCustom\">\n                          <a (click)=\"seleccionarBusqueda(busqueda.nombre)\">\n                            <img [src]=\"busqueda.icon\"\n                            class=\"card-img-top imageBusqueda\" alt=\"...\">\n                        <div class=\"card-body customBody\">\n                          {{busqueda.titulo}}\n                          <!-- <p class=\"card-text\" style=\"width: 100%\">\n                          </p> -->\n                        </div>\n                      </a>\n                    </div>\n                  </div>\n                </div>\n              </div>\n              <button id=\"btnFiltro\" type=\"button\" (click)=\"isCollapsed = !isCollapsed\"\n              [attr.aria-expanded]=\"!isCollapsed\" aria-controls=\"collapseExample\">\n                      <i class=\"fas fa-filter fa-lg\"></i>Filtros\n                    </button>\n                    <div id=\"collapseExample\" [ngbCollapse]=\"isCollapsed\">\n                      <div class=\"card\">\n                        <div class=\"card-body caja\">\n                          <ngbi-filter [filters]=\"filtrosGlobales\"></ngbi-filter>\n                        </div>\n                      </div>\n              </div> \n              <button id=\"btnResultados\" type=\"button\" (click)=\"isCollapsedR = !isCollapsedR\"\n              [attr.aria-expanded]=\"!isCollapsedR\" aria-controls=\"collapseExampleR\">\n              Resultados\n              </button>\n              <div id=\"collapseExampleR\" [ngbCollapse]=\"isCollapsedR\">\n                <div *ngFor=\"let det of infoDetalle; let i = index\" class=\"card\" style=\"width: 100%;\">\n                    <div class=\"card-body caja\">\n                      <!-- <h5 class=\"card-title\">{{i}}</h5> -->\n                      <!-- Iterar titulo y values. -->\n                      <!-- infoDetTitulo infoDetValues -->\n                      <h4>{{infoTitulos[i]}}</h4>\n                    <p ><label class=\"labelDetalle\" *ngFor=\"let item of infoDetTitulo[i]; let o = index\"> {{infoDetTitulo[i][o]}}: {{infoDetValues[i][o]}}</label></p>\n                    \n                    <span *ngIf=\"infoDetBotones.length>0\" id=\"botonesDetalle\" class=\"input-group-btn\">\n                      <button *ngFor=\"let boton of infoDetBotones[i]\" type=\"button\" [class]=\"boton.clase\" (click)=\"clickDetExt(det,boton.accion)\" > <i *ngIf=\"boton.tipo=='icono'\" [class]=\"boton.contenido\"></i> <p *ngIf=\"boton.tipo=='text'|| boton.tipo==null || boton.tipo==undefined\">{{boton.contenido}}</p></button>\n                    </span>\n                  </div>\n                </div>\n                <div *ngIf=\"infoDetalle.length>0\" style=\"display: flex; justify-content: flex-end;\">\n                  <button class=\"btn btn-primary\" (click)=\"detallePaginaAnterior()\" >Anterior</button>\n                  <button class=\"btn btn-secundary\" (click)=\"detallePaginaSiguiente()\">Siguiente</button>\n                </div>\n              </div> \n              <!-- end subpanel -->\n              <!-- <ngbi-filter [filters]=\"filtrosGlobales\"></ngbi-filter> -->\n              <div #labelActualizar class=\"footerMenuLateral\">\n                <input type=\"checkbox\" value=\"false\" [(ngModel)]=\"chkActualizarResult\" >\n                <label style=\"padding-left: 4px;\">\n                    Actualizar al mover el mapa\n                  </label>\n                </div>\n              </div>\n        </div>\n        <div id=\"map\" (click)='cerrarPopUpV2()'>\n            <button  id=\"openbtn\" class=\"openbtn\" (click)=\"openNav()\">></button>\n            <button  id=\"openBtnMas\" class=\"openBtnMas\" (click)=\"openNavMas()\">></button>\n        </div>\n    </div>\n  </div>\n\n  <!-- Menu boton defecho -->\n  <div #menu class=\"menu\">\n    <ul class=\"menu-options\">\n      <li class=\"menu-option\"><a (click)=\"buscarEnFiguraSeleccionada()\">Buscar </a></li>\n      <li class=\"menu-option\"><a (click)=\"buscarEnFiguraResultados()\">Resultados </a></li>\n      <li class=\"menu-option\"><a (click)=\"eliminarSeleccionado()\">Eliminar </a></li>\n    </ul>\n  </div>\n  <div>\n    <div id=\"popup\" class=\"ol-popup\">\n      <div id=\"scroll\">\n        <a id=\"popup-closer\" class=\"ol-popup-closer btn-links\"></a>\n        <div id=\"popup-content\"></div>\n      </div>\n    </div>\n  </div>\n  <div id=\"mouse-position\"></div>\n\n</div>\n",
                        styles: ["#map{width:100%}.componentMap{height:100%;width:100%;position:relative}#buscarArea{display:none}.footerMenuLateral{bottom:0;display:none;padding-top:11px;padding-bottom:20px}.divBuscarArea{z-index:2;position:absolute;-webkit-box-pack:center;justify-content:center;display:-webkit-box;display:flex;margin-top:1vh;width:100%}#scroll{height:37vh;width:40vw;overflow-y:scroll;overflow-x:hidden}.ol-popup{position:absolute;background-color:#fff;-webkit-filter:drop-shadow(0 1px 4px rgba(0, 0, 0, .2));filter:drop-shadow(0 1px 4px rgba(0, 0, 0, .2));padding:15px;border-radius:10px;border:1px solid #ccc;bottom:12px;left:-50px;width:44vw;height:42vh}.ol-popup:after,.ol-popup:before{top:100%;border:solid transparent;content:\" \";height:0;width:0;position:absolute;pointer-events:none}.ol-popup:after{border-top-color:#fff;border-width:10px;left:48px;margin-left:-10px}.ol-popup:before{border-top-color:#ccc;border-width:11px;left:48px;margin-left:-11px}.ol-popup-closer{text-decoration:none;position:absolute;top:2px;right:8px}.ol-popup-closer:after{content:\"\u2716\"}.centrado{margin-left:auto;margin-right:auto}.badgebox{opacity:0}.badgebox+.badge{text-indent:-999999px;width:27px}.badgebox:focus+.badge{box-shadow:inset 0 0 5px}.badgebox:checked+.badge{text-indent:0}.div-filtros{display:-webkit-box;display:flex;align-self:center;margin-right:5px}.titulo-date{color:#000;display:-webkit-box;display:flex;align-self:center}.botonMenu{background-color:#82a6ca;color:#fff}.btnbuscar{width:4rem;-webkit-box-flex:0;flex:none;margin-left:10px!important;color:#fff!important}.divMenu{background-color:#82a6ca;color:#000;width:100%}.input-filtro{width:20vw;display:inline}.switcher{display:-webkit-box;display:flex;margin-bottom:2px}.divFiltros{display:-webkit-inline-box;margin-left:10px;padding-top:6px}.custom-day{text-align:center;padding:.185rem .25rem;display:inline-block;height:2rem;width:2rem}.custom-day.focused{background-color:#e6e6e6}.custom-day.range,.custom-day:hover{background-color:#0275d8;color:#fff}.custom-day.faded{background-color:rgba(2,117,216,.5)}.itemFiltro{display:-webkit-inline-box;margin-left:10px}.show-ranges{left:315px!important}.md-drppicker{color:#000!important}.custom-panel{display:-webkit-box;display:flex;-webkit-box-orient:vertical;-webkit-box-direction:normal;flex-direction:column}.caja{border:1px solid;margin-bottom:5px}#inputDirecciones{width:100%;display:-webkit-box;z-index:900;background-color:rgba(255,255,255,.8);border-color:#5f9ea0}.Search{position:absolute;display:list-item;top:25vh;background:rgba(255,255,255,.5);left:1vw}.Search button{margin-left:6vw;margin-right:6vw}.Search label{margin-left:1vw}.Search input{width:50%;margin-left:1vw}.Search select{margin-top:6px;margin-left:1vw}#OptionExtrasBusquedas{z-index:1;width:100%}.imageBusqueda{border-radius:30%;height:4rem;width:5rem}.customBody{width:auto;padding:0!important;display:-webkit-box;display:flex;-webkit-box-pack:center;justify-content:center}.cardCustom{width:5rem}body{font-family:Lato,sans-serif}.sidepanel{z-index:3;height:100%;width:0;background-color:rgba(255,255,255,1);overflow-y:auto;overflow-x:hidden;-webkit-transition:.5s;transition:.5s;margin-bottom:0;position:absolute}.sidepanel input{background-color:rgba(255,255,255,.7)}.sidepanel a{text-decoration:none;font-size:14px;color:#818181;display:block;-webkit-transition:.3s;transition:.3s}.sidepanel a:hover{color:rgba(241,241,241)}.closebtn{position:absolute;top:0;right:0;font-size:36px!important;color:#fff}.openbtn{display:block;font-size:20px;cursor:pointer;background-color:rgba(79,131,183,.7);color:#fff;padding:6px 10px;border:none;position:absolute;margin-top:7rem;z-index:2;border-radius:4px}.openBtnMas{display:none;position:absolute;margin-top:7rem;margin-left:30%;font-size:20px;cursor:pointer;background-color:rgba(79,131,183,.7);color:#fff;padding:6px 10px;border:none;z-index:2;border-radius:4px}.labelDetalle{margin-bottom:.1rem!important;font-weight:100!important;display:-webkit-box;display:flex}.openBtnMas:hover,.openbtn:hover{background-color:rgba(218,218,218,.7)}.available{color:#000!important}.menu{width:120px;box-shadow:0 4px 5px 3px rgba(0,0,0,.2);position:absolute;display:none;z-index:2;background-color:rgba(255,255,255,.904)}.menu-options{list-style:none;padding:10px 0}.menu-option{font-weight:500;font-size:14px;padding:10px 40px 10px 20px;cursor:pointer}menu:hover{background:rgba(0,0,0,.2)}#btnFiltro{border:1px solid;width:100%;height:6vh;background-color:#fff;text-align:left;border-radius:.35rem}#btnFiltro:hover,#btnResultados:hover{background-color:rgba(241,241,241,.5)}#btnResultados{border-radius:.35rem;border:1px solid;width:100%;height:6vh;background-color:#fff;text-align:left}"]
                    }] }
        ];
        /** @nocollapse */
        MapaComponent.ctorParameters = function () {
            return [
                { type: ngBootstrap.NgbModal },
                { type: http.HttpClient },
                { type: ngxSpinner.NgxSpinnerService },
                { type: ngBootstrap.NgbCalendar },
                { type: ngBootstrap.NgbDropdownConfig },
                { type: i0.ElementRef },
                { type: i0.Renderer2 },
                { type: ngBootstrap.NgbDateParserFormatter }
            ];
        };
        MapaComponent.propDecorators = {
            app: [{ type: i0.Input, args: ['App',] }],
            urlConfiguracion: [{ type: i0.Input, args: ['Url',] }],
            filtroInicial: [{ type: i0.Input, args: ['filtroInicial',] }],
            filtroConcat: [{ type: i0.Input, args: ['filtroConcat',] }],
            clicExterno: [{ type: i0.Output }],
            menuElement: [{ type: i0.ViewChild, args: ['menu', null,] }],
            direccionesElement: [{ type: i0.ViewChild, args: ['inputDirecciones', null,] }],
            colorPicker: [{ type: i0.ViewChild, args: ['colorPicker', null,] }],
            buscarArea: [{ type: i0.ViewChild, args: ['buscarArea', null,] }],
            labelActualizar: [{ type: i0.ViewChild, args: ['labelActualizar', null,] }],
            handleKeyboardDownEvent: [{ type: i0.HostListener, args: ['document:keydown', ['$event'],] }],
            handleKeyboardUpEvent: [{ type: i0.HostListener, args: ['document:keyup', ['$event'],] }]
        };
        return MapaComponent;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/mapa/table-data/table-data.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /*const COUNTRIES: any[] = [
      {
        name: 'Russia',
        flag: 'f/f3/Flag_of_Russia.svg',
        area: 17075200,
        population: 146989754
      },
      {
        name: 'France',
        flag: 'c/c3/Flag_of_France.svg',
        area: 640679,
        population: 64979548
      },
      {
        name: 'Germany',
        flag: 'b/ba/Flag_of_Germany.svg',
        area: 357114,
        population: 82114224
      },
      {
        name: 'Portugal',
        flag: '5/5c/Flag_of_Portugal.svg',
        area: 92090,
        population: 10329506
      },
      {
        name: 'Canada',
        flag: 'c/cf/Flag_of_Canada.svg',
        area: 9976140,
        population: 36624199
      },
      {
        name: 'Vietnam',
        flag: '2/21/Flag_of_Vietnam.svg',
        area: 331212,
        population: 95540800
      },
      {
        name: 'Brazil',
        flag: '0/05/Flag_of_Brazil.svg',
        area: 8515767,
        population: 209288278
      },
      {
        name: 'Mexico',
        flag: 'f/fc/Flag_of_Mexico.svg',
        area: 1964375,
        population: 129163276
      },
      {
        name: 'United States',
        flag: 'a/a4/Flag_of_the_United_States.svg',
        area: 9629091,
        population: 324459463
      },
      {
        name: 'India',
        flag: '4/41/Flag_of_India.svg',
        area: 3287263,
        population: 1324171354
      },
      {
        name: 'Indonesia',
        flag: '9/9f/Flag_of_Indonesia.svg',
        area: 1910931,
        population: 263991379
      },
      {
        name: 'Tuvalu',
        flag: '3/38/Flag_of_Tuvalu.svg',
        area: 26,
        population: 11097
      },
      {
        name: 'China',
        flag: 'f/fa/Flag_of_the_People%27s_Republic_of_China.svg',
        area: 9596960,
        population: 1409517397
      }
    ];*/
    var TableDataPage = /** @class */ (function () {
        function TableDataPage(http$$1, activeModal) {
            this.http = http$$1;
            this.activeModal = activeModal;
            this.status = true;
            this.configuracion = {
                columnas: [
                    { nombre: "nombre", propiedad: "name" },
                    { nombre: "area", propiedad: "area" },
                    { nombre: "Poblacion", propiedad: "population" }
                ]
            };
            this.columnas = [];
            this.datos = [];
            this.page = 1;
            this.pageSize = 10;
            this.collectionSize = 0;
        }
        /**
         * @return {?}
         */
        TableDataPage.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.buscarDatos();
            };
        Object.defineProperty(TableDataPage.prototype, "countries", {
            get: /**
             * @return {?}
             */ function () {
                return this.datos
                    .map(( /**
             * @param {?} datos
             * @param {?} i
             * @return {?}
             */function (datos, i) { return (__assign({ id: i + 1 }, datos)); }))
                    .slice((this.page - 1) * this.pageSize, (this.page - 1) * this.pageSize + this.pageSize);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @return {?}
         */
        TableDataPage.prototype.buscarDatos = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                this.datos = [];
                /** @type {?} */
                var newParams = {
                    page: this.page,
                    pageSize: this.pageSize
                };
                Object.assign(this.params, newParams);
                console.log("Parametros Modal>>", this.params);
                this.http.post(this.URL, this.params, { headers: new http.HttpHeaders({ 'Content-Type': 'application/json' }) }).subscribe(( /**
                 * @param {?} response
                 * @return {?}
                 */function (response) {
                    console.log("This is the response data>>>>>>", response);
                    if (response == null || response == undefined || response[0] == null || response[0] == undefined) {
                        _this.activeModal.close();
                        console.log("Alerta", "No se encontraron datos");
                        return;
                    }
                    _this.columnas = Object.keys(response[0]);
                    _this.columnas.splice(_this.columnas.indexOf('Exterior'), 1);
                    _this.columnas.splice(_this.columnas.indexOf('FechaNacimiento'), 1);
                    _this.columnas.splice(_this.columnas.indexOf('Interior'), 1);
                    _this.columnas.splice(_this.columnas.indexOf('Sexo'), 1);
                    _this.columnas.splice(_this.columnas.indexOf('tipoBusqueda'), 1);
                    _this.columnas.splice(_this.columnas.indexOf('tipoConsulta'), 1);
                    _this.datos = response;
                    _this.collectionSize = _this.datos.length * _this.page;
                    console.log("Objeto KEYS", Object.keys(response[0]));
                    console.log("thisdata><", _this.datos);
                }));
            };
        /**
         * @return {?}
         */
        TableDataPage.prototype.paginaSiguiente = /**
         * @return {?}
         */
            function () {
                this.page++;
                this.buscarDatos();
            };
        /**
         * @return {?}
         */
        TableDataPage.prototype.paginaAnterior = /**
         * @return {?}
         */
            function () {
                this.page--;
                this.buscarDatos();
            };
        TableDataPage.decorators = [
            { type: i0.Component, args: [{
                        selector: 'table-data',
                        template: "<table class=\"table \">\r\n  <thead>\r\n    <tr>\r\n      <th scope=\"col\">#</th>\r\n      <th *ngFor=\"let columna of columnas\" scope=\"col\">{{columna}}</th>\r\n    </tr>\r\n  </thead>\r\n  <tbody>\r\n    <tr *ngFor=\"let country of datos\">\r\n      <th scope=\"row\">{{ country.id }}</th>\r\n      <td *ngFor=\"let columna of columnas\">{{ country[columna] }}</td>\r\n    </tr>\r\n  </tbody>\r\n</table>\r\n<div>\r\n  <select class=\"custom-select\" style=\"width: auto\" [(ngModel)]=\"pageSize\">\r\n    <option [ngValue]=\"5\">5 items per page</option>\r\n    <option [ngValue]=\"10\">10 items per page</option>\r\n    <option [ngValue]=\"15\">15 items per page</option>\r\n  </select>\r\n</div>\r\n<div class=\"d-flex justify-content-between p-2\">\r\n  <div class=\"btn-group\" role=\"group\" aria-label=\"Basic example\">\r\n      <button type=\"button\" (click)=\"paginaAnterior()\" class=\"btn btn-secondary\" *ngIf=\"page>1\">Anterior</button>\r\n      <button type=\"button\" class=\"btn btn-secondary\">{{page}}</button>\r\n      <button type=\"button\" (click)=\"paginaSiguiente()\" class=\"btn btn-secondary\" *ngIf=\"datos.length>pageSize\">Siguiente</button>\r\n  </div>\r\n  <!-- <ngb-pagination [collectionSize]=\"collectionSize\" [(page)]=\"page\" [pageSize]=\"pageSize\">\r\n  </ngb-pagination> -->\r\n\r\n</div>\r\n",
                        encapsulation: i0.ViewEncapsulation.None,
                        styles: [".modal-dialog{max-width:-webkit-max-content;max-width:-moz-max-content;max-width:max-content}"]
                    }] }
        ];
        /** @nocollapse */
        TableDataPage.ctorParameters = function () {
            return [
                { type: http.HttpClient },
                { type: ngBootstrap.NgbActiveModal }
            ];
        };
        return TableDataPage;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngbi-map.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgbiMapModule = /** @class */ (function () {
        function NgbiMapModule() {
        }
        NgbiMapModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [NgbiMapComponent, MapaComponent, TableDataPage],
                        imports: [
                            ngBootstrap.NgbModule,
                            forms.FormsModule,
                            http.HttpClientModule,
                            ngxSpinner.NgxSpinnerModule,
                            ngxColorPicker.ColorPickerModule,
                            ngbiFilters.FiltersModule,
                            ngBootstrap.NgbPaginationModule,
                            ngBootstrap.NgbAlertModule,
                            platformBrowser.BrowserModule
                        ],
                        entryComponents: [
                            TableDataPage
                        ],
                        exports: [NgbiMapComponent, MapaComponent]
                    },] }
        ];
        return NgbiMapModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngbi-map.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NgbiMapService = NgbiMapService;
    exports.NgbiMapComponent = NgbiMapComponent;
    exports.NgbiMapModule = NgbiMapModule;
    exports.MapaComponent = MapaComponent;
    exports.ɵa = TableDataPage;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngbi-map.umd.js.map